/* A Bison parser, made by GNU Bison 3.4.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs

#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 27 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"


//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int  yylex();
extern int CISAlineno;

static bool ParseAlign(CISA_IR_Builder* pCisaBuilder, const char *sym, VISA_Align &value);
static bool ParseEMask(CISA_IR_Builder* pCisaBuilder, const char* sym, VISA_EMask_Ctrl &emask);

/*
 * check if the cond is true.
 * if cond is false, then print errorMessage (syntax error) and YYABORT
 */
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pCisaBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR(...)\
  {pCisaBuilder->RecordParseError(CISAlineno, __VA_ARGS__); YYABORT;}
#ifdef _DEBUG
#define TRACE(str) fprintf(CISAout, str)
#else
#define TRACE(str)
#endif

char * switch_label_array[32];
std::vector<VISA_opnd*> RTWriteOperands;
VISA_opnd *opndRTWriteArray[32];
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

#ifndef PRId64
# ifdef _WIN32
#   define PRId64 "I64d"
# else
#   if __WORDSIZE == 64
#     define PRId64 "ld"
#   else
#     define PRId64 "lld"
#   endif
# endif
#endif

#ifdef _MSC_VER
#pragma warning(disable:4065; disable:4267)
#endif


#line 139 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"

# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_CISA_BUILDDIR_BUILD_BUILD_INTEL_GRAPHICS_COMPILER_6934FA8D2714031192E8D67CF54D89B68B1FF74E_BUILD_IGC_VISA_CISA_TAB_HPP_INCLUDED
# define YY_CISA_BUILDDIR_BUILD_BUILD_INTEL_GRAPHICS_COMPILER_6934FA8D2714031192E8D67CF54D89B68B1FF74E_BUILD_IGC_VISA_CISA_TAB_HPP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int CISAdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DIRECTIVE_KERNEL = 258,
    DIRECTIVE_VERSION = 259,
    DIRECTIVE_ENTRY = 260,
    DIRECTIVE_DECL = 261,
    FUNC_DIRECTIVE_DECL = 262,
    DIRECTIVE_ATTR = 263,
    DIRECTIVE_KERNEL_ATTR = 264,
    DIRECTIVE_INPUT = 265,
    DIRECTIVE_PARAMETER = 266,
    DIRECTIVE_LOC = 267,
    DIRECTIVE_FUNC = 268,
    DIRECTIVE_GLOBAL_FUNC = 269,
    SRCMOD_NEG = 270,
    SRCMOD_ABS = 271,
    SRCMOD_NEGABS = 272,
    SRCMOD_NOT = 273,
    SAT = 274,
    PIXEL_NULL_MASK = 275,
    CPS = 276,
    NON_UNIFORM_SAMPLER = 277,
    ALIAS = 278,
    ALIGN = 279,
    RAW_SEND_STRING = 280,
    RAW_SENDC_STRING = 281,
    RAW_SENDS_STRING = 282,
    RAW_SENDS_EOT_STRING = 283,
    RAW_SENDSC_STRING = 284,
    RAW_SENDSC_EOT_STRING = 285,
    ATOMIC_SUB_OP = 286,
    PHYSICAL_REGISTER = 287,
    ITYPE = 288,
    DECL_DATA_TYPE = 289,
    DFTYPE = 290,
    FTYPE = 291,
    HFTYPE = 292,
    TYPE = 293,
    VTYPE = 294,
    FLOATINGPOINT = 295,
    DOUBLEFLOAT = 296,
    NUMBER = 297,
    HEX_NUMBER = 298,
    COND_MOD = 299,
    LANGLE = 300,
    RANGLE = 301,
    LBRACK = 302,
    RBRACK = 303,
    IND_LBRACK = 304,
    LPAREN = 305,
    RPAREN = 306,
    LBRACE = 307,
    RBRACE = 308,
    DOT = 309,
    COMMA = 310,
    SEMI = 311,
    COLON = 312,
    SLASH = 313,
    EQUALS = 314,
    PLUS = 315,
    MINUS = 316,
    TIMES = 317,
    AMP = 318,
    TILDE = 319,
    BANG = 320,
    LABEL = 321,
    IMPLICIT_INPUT = 322,
    OFFSET = 323,
    SLM_SIZE = 324,
    PRED_CNTL = 325,
    CHAN4_MASK = 326,
    VAR = 327,
    NULL_VAR = 328,
    COMMENT_LINE = 329,
    STMT_DELIM = 330,
    INPUT_VAR = 331,
    NUM_ELTS = 332,
    V_NAME_TOKEN = 333,
    SIZE = 334,
    FLAG_REG_NAME = 335,
    SURF_USE_NAME = 336,
    F_CLASS = 337,
    G_CLASS = 338,
    P_CLASS = 339,
    A_CLASS = 340,
    S_CLASS = 341,
    T_CLASS = 342,
    RTWRITE_OPTION = 343,
    STRING_LITERAL = 344,
    ALIGNTYPE_2GRF = 345,
    MEDIA_MODE = 346,
    OWORD_MODIFIER = 347,
    SAMPLER_CHANNEL = 348,
    SLM_CHANNEL = 349,
    CHANNEL_OUTPUT = 350,
    VME_TYPE = 351,
    FILE_EOF = 352,
    EXECMODE = 353,
    CNTRL = 354,
    FENCE_OPTIONS = 355,
    THREE_OPERAND_OP = 356,
    TWO_OPERAND_OP = 357,
    MOD_OP = 358,
    ADDR_ADD_OP = 359,
    UNARY_LOGIC_OP = 360,
    BINARY_LOGIC_OP = 361,
    TERNARY_LOGIC_OP = 362,
    QUATERNARY_LOGIC_OP = 363,
    SEL_OP = 364,
    MIN_OP = 365,
    MAX_OP = 366,
    ANTI_TRIG_OP = 367,
    MATH2_OP = 368,
    MATH3_OP = 369,
    ARITH2_OP = 370,
    ARITH3_OP = 371,
    ARITH4_OP = 372,
    ARITH4_OP2 = 373,
    CMP_OP = 374,
    SVM_OP = 375,
    SVM_SCATTER_OP = 376,
    SVM_GATHER4SCALED_OP = 377,
    SVM_SCATTER4SCALED_OP = 378,
    SVM_ATOMIC_OP = 379,
    OWORD_OP = 380,
    MEDIA_OP = 381,
    SCATTER_OP = 382,
    SCATTER_TYPED_OP = 383,
    SCATTER_SCALED_OP = 384,
    SCATTER4_SCALED_OP = 385,
    BARRIER_OP = 386,
    SBARRIER_SIGNAL = 387,
    SBARRIER_WAIT = 388,
    ATOMIC_OP = 389,
    DWORD_ATOMIC_OP = 390,
    TYPED_ATOMIC_OP = 391,
    SAMPLE_OP = 392,
    SAMPLE_UNORM_OP = 393,
    SURFACE_OP = 394,
    VME_IME_OP = 395,
    VME_SIC_OP = 396,
    VME_FBR_OP = 397,
    BRANCH_OP = 398,
    IFCALL = 399,
    FCALL = 400,
    FADDR = 401,
    SWITCHJMP_OP = 402,
    MOVS_OP = 403,
    SETP_OP = 404,
    MOV_OP = 405,
    FILE_OP = 406,
    LOC_OP = 407,
    CACHE_FLUSH_OP = 408,
    WAIT_OP = 409,
    FENCE_GLOBAL_OP = 410,
    FENCE_LOCAL_OP = 411,
    FENCE_SW_OP = 412,
    YIELD_OP = 413,
    SAMPLE_3D_OP = 414,
    LOAD_3D_OP = 415,
    SAMPLE4_3D_OP = 416,
    RESINFO_OP_3D = 417,
    SAMPLEINFO_OP_3D = 418,
    RTWRITE_OP_3D = 419,
    URBWRITE_OP_3D = 420,
    LIFETIME_START_OP = 421,
    LIFETIME_END_OP = 422,
    AVS_OP = 423,
    NEG = 424
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 93 "CISA.y"

    int64_t                number;
    double                 fp;

    struct strlitbuf_struct {
        char      decoded[4096];
        size_t    len;
    } strlit;
    char *                 string;
    char *                 asm_name;
    char *                 var_name;

    VISA_Type              type;
    ISA_Opcode             opcode;
    VISA_Cond_Mod    mod;
    //G4_Type              g4_type;
    //G4_Operand*          opnd;

    bool                   sat;
    short                  shortnum;
    unsigned short         ushortnum;

    struct {
        //G4_CondModifier        mod;
        VISA_Cond_Mod cisa_mod;
    } cond_mod;
    struct {
        VISA_opnd * cisa_gen_opnd;
    } cisa_pred;

    struct {
        //G4_PredState           state;
        VISA_PREDICATE_STATE cisa_state;
    } pred_state;

    struct {
        //G4_SrcModifier         srcMod;
        VISA_Modifier mod;
    } src_mod;

    struct {
        unsigned int v_stride;
        unsigned int h_stride;
        unsigned int width;
        //RegionDesc*              rgn;
    } cisa_region;

    struct  {
        int                row;
        int                elem;
    } offset;

    struct {
        //G4_Operand*        opnd;
        Common_ISA_Operand_Class type;
       // VISA_opnd * cisa_gen_opnd;
    } dstOpnd;

    struct {
        //G4_Operand*        opnd;
        Common_ISA_Operand_Class type;
       // VISA_opnd * cisa_gen_opnd;
    } srcOpnd;

    struct {
        //G4_Operand*        opnd;
        Common_ISA_Operand_Class type;
        VISA_opnd * cisa_gen_opnd;
    } genOperand;

    struct {
        //G4_Operand*        opnd;
        Common_ISA_Operand_Class type;
        Common_ISA_Function_Parameters_Kind kind;
        char * var_name; //for Surface, VME, Sampler
        //for raw operand
        //G4_Declare *dcl;
        unsigned short offset;
    } srcFuncOpnd;

    struct {
        char * var_name;
        //G4_Operand*        opnd;
        VISA_opnd * cisa_gen_opnd;
        unsigned char streamMode;
        unsigned char searchCtrl;
    } vmeOpndIvb;

    struct {
        //G4_Operand* fbrMbMode;
        //G4_Operand* fbrSubMbShape;
        //G4_Operand* fbrSubPredMode;

        VISA_opnd * cisa_fbrMbMode_opnd;
        VISA_opnd * cisa_fbrSubMbShape_opnd;
        VISA_opnd * cisa_fbrSubPredMode_opnd;
    } vmeOpndFbr;

    struct {
        //G4_Operand*        opnd;
        int                row;
        int                elem;
        int                immOff;
        //G4_RegAccess       acc;
        VISA_opnd * cisa_gen_opnd;
        CISA_GEN_VAR * cisa_decl;
    } regAccess;

    struct{
        char *             aliasname;
        int                offset;
    } alias;

    struct {
        //G4_Declare *dcl;
        unsigned short offset;
        VISA_opnd * cisa_gen_opnd;
    } RawVar;

    struct {
        //G4_Declare *dcl;
        Common_ISA_State_Opnd type;
        unsigned char offset;
        VISA_opnd * cisa_gen_opnd;
    } StateVar;

    struct {
        VISA_EMask_Ctrl emask;
        int exec_size;
    } emask_exec_size;

    /*
        MUST MATCH DEFINITION IN Common_ISA_framework.h!!!!!!!!!!
    */
    struct attr_gen_struct {
        char *             name;
        bool               isInt;
        int                value;
        char *             string_val;
        bool               attr_set;
    } attr_gen;


    /* Align Support in Declaration*/
    VISA_Align             CISA_align;
    VISA_Align             align;

    VISAAtomicOps          atomic_op;
    VISASampler3DSubOpCode sample3DOp;

    MEDIA_LD_mod           media_mode;
    bool                   oword_mod;
    VISAChannelMask        s_channel; // Cannot use ChannelMask here as it's a member of union where non-trivial constructor is not allowed.
    CHANNEL_OUTPUT_FORMAT  s_channel_output;
    COMMON_ISA_VME_OP_MODE VME_type;
    VISA_EMask_Ctrl emask;
    OutputFormatControl    cntrl;
    AVSExecMode            execMode;
    bool                   file_end;
    unsigned char          fence_options;

    // Pixel null mask for sampler instructions.
    bool                   pixel_null_mask;

    // CPS LOD compensation enable for 3d sample.
    bool                   cps;
    bool                   non_uniform_sampler;
    bool                   flag;

#line 522 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE CISAlval;

int CISAparse (CISA_IR_Builder* pCisaBuilder);

#endif /* !YY_CISA_BUILDDIR_BUILD_BUILD_INTEL_GRAPHICS_COMPILER_6934FA8D2714031192E8D67CF54D89B68B1FF74E_BUILD_IGC_VISA_CISA_TAB_HPP_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1626

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  170
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  141
/* YYNRULES -- Number of rules.  */
#define YYNRULES  336
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  842

#define YYUNDEFTOK  2
#define YYMAXUTOK   424

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   537,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   555,   559,   565,
     570,   570,   577,   585,   592,   593,   597,   603,   604,   605,
     606,   607,   608,   610,   616,   630,   642,   656,   664,   679,
     686,   693,   699,   702,   705,   711,   716,   717,   720,   721,
     725,   726,   730,   733,   736,   742,   748,   752,   757,   761,
     766,   773,   778,   785,   793,   805,   806,   807,   808,   809,
     810,   811,   812,   813,   814,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     830,   831,   832,   833,   834,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   857,   861,   865,   869,   875,   879,   885,   891,   897,
     904,   912,   918,   925,   931,   937,   943,   949,   955,   961,
     965,   971,   975,   979,   985,   990,   995,  1001,  1007,  1013,
    1019,  1025,  1029,  1033,  1039,  1045,  1052,  1058,  1064,  1070,
    1076,  1082,  1088,  1094,  1100,  1102,  1106,  1111,  1119,  1125,
    1133,  1151,  1157,  1172,  1179,  1184,  1189,  1194,  1199,  1206,
    1209,  1213,  1220,  1224,  1228,  1233,  1238,  1244,  1250,  1255,
    1260,  1265,  1271,  1277,  1282,  1288,  1294,  1300,  1306,  1310,
    1314,  1318,  1322,  1326,  1330,  1334,  1341,  1342,  1345,  1347,
    1350,  1355,  1359,  1367,  1370,  1382,  1386,  1393,  1394,  1398,
    1399,  1403,  1404,  1405,  1406,  1409,  1413,  1422,  1425,  1428,
    1430,  1434,  1436,  1438,  1440,  1442,  1444,  1446,  1449,  1451,
    1453,  1455,  1457,  1460,  1462,  1464,  1466,  1469,  1471,  1473,
    1475,  1488,  1494,  1505,  1509,  1515,  1519,  1528,  1533,  1538,
    1559,  1567,  1570,  1577,  1589,  1599,  1603,  1607,  1613,  1621,
    1630,  1638,  1639,  1640,  1641,  1644,  1655,  1666,  1674,  1680,
    1694,  1695,  1696,  1699,  1705,  1719,  1731,  1744,  1751,  1761,
    1762,  1768,  1774,  1783,  1794,  1804,  1814,  1825,  1826,  1834,
    1835,  1843,  1844,  1851,  1858,  1862,  1868,  1878,  1886,  1898,
    1899,  1900,  1901,  1902,  1907,  1908,  1910,  1912,  1916,  1918,
    1925,  1932,  1937,  1939,  1943,  1950,  1957,  1962,  1969,  1974,
    1980,  1986,  1987,  1988,  1989,  1990,  1993,  1999,  2000,  2006,
    2007,  2013,  2014,  2020,  2021,  2028,  2028
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DIRECTIVE_KERNEL", "DIRECTIVE_VERSION",
  "DIRECTIVE_ENTRY", "DIRECTIVE_DECL", "FUNC_DIRECTIVE_DECL",
  "DIRECTIVE_ATTR", "DIRECTIVE_KERNEL_ATTR", "DIRECTIVE_INPUT",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_LOC", "DIRECTIVE_FUNC",
  "DIRECTIVE_GLOBAL_FUNC", "SRCMOD_NEG", "SRCMOD_ABS", "SRCMOD_NEGABS",
  "SRCMOD_NOT", "SAT", "PIXEL_NULL_MASK", "CPS", "NON_UNIFORM_SAMPLER",
  "ALIAS", "ALIGN", "RAW_SEND_STRING", "RAW_SENDC_STRING",
  "RAW_SENDS_STRING", "RAW_SENDS_EOT_STRING", "RAW_SENDSC_STRING",
  "RAW_SENDSC_EOT_STRING", "ATOMIC_SUB_OP", "PHYSICAL_REGISTER", "ITYPE",
  "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "TYPE", "VTYPE",
  "FLOATINGPOINT", "DOUBLEFLOAT", "NUMBER", "HEX_NUMBER", "COND_MOD",
  "LANGLE", "RANGLE", "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN",
  "LBRACE", "RBRACE", "DOT", "COMMA", "SEMI", "COLON", "SLASH", "EQUALS",
  "PLUS", "MINUS", "TIMES", "AMP", "TILDE", "BANG", "LABEL",
  "IMPLICIT_INPUT", "OFFSET", "SLM_SIZE", "PRED_CNTL", "CHAN4_MASK", "VAR",
  "NULL_VAR", "COMMENT_LINE", "STMT_DELIM", "INPUT_VAR", "NUM_ELTS",
  "V_NAME_TOKEN", "SIZE", "FLAG_REG_NAME", "SURF_USE_NAME", "F_CLASS",
  "G_CLASS", "P_CLASS", "A_CLASS", "S_CLASS", "T_CLASS", "RTWRITE_OPTION",
  "STRING_LITERAL", "ALIGNTYPE_2GRF", "MEDIA_MODE", "OWORD_MODIFIER",
  "SAMPLER_CHANNEL", "SLM_CHANNEL", "CHANNEL_OUTPUT", "VME_TYPE",
  "FILE_EOF", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "THREE_OPERAND_OP",
  "TWO_OPERAND_OP", "MOD_OP", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "ATOMIC_OP",
  "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP",
  "SURFACE_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP",
  "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP",
  "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP",
  "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP",
  "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D",
  "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "NEG", "$accept",
  "CISAStmt", "TrailingComment", "EndOfFile", "StrLitOrVar",
  "DirectiveKernel", "DirectiveGlobalFunction", "V_NAME",
  "DirectiveVersion", "DirectiveDecl", "DeclFunctions", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "DeclSurface",
  "DirectiveInput", "DirectiveImplicitInput", "DirectiveParameter",
  "DirectiveAttr", "DirectiveFunc", "FUNCTION_NAME", "SIZE_NUM",
  "OFFSET_NUM", "AlignType", "AliasInfo", "GEN_ATTR", "CISAInst",
  "LogicInstruction", "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND",
  "AntiTrigInstruction", "AddrAddInstruction", "SetpInstruction",
  "SelInstruction", "MinInstruction", "MaxInstruction", "MovInstruction",
  "MovsInstruction", "CmpInstruction", "MediaInstruction",
  "ScatterInstruction", "ScatterTypedInstruction",
  "Scatter4ScaledInstruction", "ScatterScaledInstruction",
  "SynchronizationInstruction", "DwordAtomicInstruction",
  "TypedAtomicInstruction", "SampleUnormInstruction", "SampleInstruction",
  "Sample3dInstruction", "Load3dInstruction", "Gather43dInstruction",
  "ResInfo3dInstruction", "SampleInfo3dInstruction", "RTWriteOperandParse",
  "RTWriteInstruction", "URBWriteInstruction", "AVSInstruction",
  "VMEInstruction", "OwordInstruction", "SvmInstruction", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NO_OPND_INST", "OwordModifier", "TargetLabel", "SymbolName", "ScopeOp",
  "Predicate", "PredState", "PredCntrl", "InstModifier", "SrcModifier",
  "ConditionalModifier", "VecDstOperand_A", "VecDstOperand_G",
  "VecDstOperand_G_I", "VecSrcOperand_G_I_IMM_A", "VecSrcOperand_G_I_IMM",
  "VecSrcOperand_G_IMM", "VecSrcOperand_A_G", "VMEOpndIME", "VMEOpndFBR",
  "SrcStateOperand", "DstStateOperand", "DstAddrOperand", "RawOperand",
  "RawOperandArray", "DstGeneralOperand", "DstIndirectOperand",
  "AddrOfOperand", "SrcAddrOperand", "SrcGeneralOperand",
  "SrcGeneralOperand_1", "SrcImmOperand", "SrcIndirectOperand",
  "SrcIndirectOperand_1", "DstRegion", "SrcRegion", "IndirectRegion",
  "Region", "RegionWH", "RegionV", "IndirectVar", "AddrParam",
  "ImmAddrOffset", "TwoDimOffset", "AddrVar", "AddressableVar", "PlaneID",
  "SIMDMode", "RTWRITE_MODE", "ElemNum", "ExecSize", "ExecSizeInt", "Imm",
  "Exp", "AbstractNum", "DoubleFloat", "FloatPoint", "DFImm", "FpImm",
  "HFImm", "DataType", "CommentLine", "PIXEL_NULL_MASK_ENABLE",
  "CPS_ENABLE", "NON_UNIFORM_SAMPLER_ENABLE", "IS_ATOMIC16",
  "ATOMIC_BITWIDTH", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424
};
# endif

#define YYPACT_NINF -776

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-776)))

#define YYTABLE_NINF -57

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -776,  1213,  -776,   -43,     3,   -42,   -32,    30,    39,    47,
     -13,   -43,    56,  -776,  -776,  -776,    94,  -776,  -776,  -776,
      78,   107,    78,    63,   100,   103,  -776,  -776,  -776,    81,
     101,   143,   126,   149,   135,    78,    78,    78,   111,   172,
    -776,   163,   117,   121,  -776,  -776,    78,    78,   151,   153,
     139,  -776,   160,   160,   160,   160,  -776,  -776,  -776,  -776,
    -776,  -776,   160,   160,   160,   160,   160,   160,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,   160,  1358,   162,  -776,  -776,  -776,   184,
     302,  -776,   182,   174,   167,  -776,  -776,  -776,  -776,  -776,
     192,   174,   -14,   193,  -776,    78,   411,  -776,    78,   221,
     231,    78,   230,   197,   251,   224,    32,   411,   226,  -776,
     -28,   411,   232,   236,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,    64,   105,   106,    83,   237,   221,   238,  -776,
    -776,  -776,  -776,  -776,  -776,    33,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,   209,   218,  -776,  -776,   244,  -776,
     242,   243,   260,   262,   264,   265,   267,   271,   273,   276,
     277,    78,    78,   103,   103,   103,   103,   300,   300,   300,
     300,   300,   300,   300,   300,   300,   300,   300,   300,   300,
      78,   301,   261,   268,   326,   269,   306,   270,   336,   338,
      78,    78,    78,   300,   351,   351,   351,   285,    78,  -776,
     332,   346,   304,   313,   331,   334,   -25,   367,   167,   372,
     410,   350,   167,  -776,   368,   373,   375,     8,  -776,  -776,
     -18,   193,    -7,    32,  -776,  -776,  -776,  -776,  -776,   398,
     376,   106,   387,  -776,    63,   405,   390,   391,   412,    32,
     414,   416,    32,   418,    32,   221,  -776,  -776,  -776,   398,
     421,   443,   394,   415,  -776,   411,  -776,  -776,   432,  -776,
    -776,  -776,  -776,  -776,   106,   355,    79,  -776,  -776,  -776,
    -776,    85,   449,   221,  -776,  -776,  -776,  -776,  -776,   106,
     106,   106,   106,  -776,   423,   425,   429,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,   463,   465,
     103,   103,   103,   103,  -776,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,   -28,   467,
      78,    78,   453,    78,   472,    78,   466,   466,   -12,   411,
     135,    78,  -776,   497,   428,   434,  -776,    78,   487,  -776,
     454,   490,   496,   498,   499,  -776,  -776,  -776,   410,  -776,
     470,  -776,  -776,   488,   410,   501,  -776,   106,   494,   163,
    -776,  -776,  -776,  -776,  -776,   462,   411,   500,   491,   398,
    -776,   106,   401,  -776,  -776,  -776,   411,   455,   505,   478,
     502,    96,   484,   512,    32,   516,   517,    32,   411,    32,
     515,   401,    20,   134,   511,  -776,   514,  -776,  -776,  -776,
    -776,  -776,   106,   106,   106,  -776,   449,  -776,  -776,  -776,
    -776,    32,    32,   411,   520,   523,   103,   103,   103,   103,
       6,     7,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,
     -28,   -28,   -28,   -28,   513,   411,   411,   524,    78,   503,
      78,   504,   526,    78,    78,  -776,  -776,  -776,   527,   528,
     -28,  -776,   549,    78,    78,   506,   530,   531,   410,   410,
     507,   507,  -776,   518,  -776,  -776,   532,   283,   106,  -776,
     106,   411,   411,  -776,   106,  -776,   401,   239,  -776,    32,
     106,  -776,   411,   411,  -776,   -11,    32,   411,   533,    32,
    -776,  -776,  -776,   519,    32,   539,  -776,  -776,    20,    20,
     536,   537,   540,   159,    92,    92,    74,  -776,    32,  -776,
     411,   547,   548,   103,   103,    78,    78,    -9,   411,    24,
     411,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   553,    32,    32,  -776,    32,    32,   529,
     411,  -776,   534,   535,   558,   570,   147,  -776,   525,   411,
     411,  -776,    32,   567,  -776,  -776,   541,   410,   410,   -22,
    -776,   571,   106,   317,   384,  -776,  -776,   208,  -776,  -776,
     106,   106,  -776,   424,   411,    32,    32,    32,   411,  -776,
      32,   411,  -776,   573,  -776,  -776,  -776,  -776,   566,   566,
     106,  -776,   411,   163,   163,    78,    78,   163,   163,  -776,
    -776,   550,   411,   411,   411,   411,   411,   411,  -776,  -776,
     411,  -776,   411,   411,   411,    78,    32,    32,    32,    32,
     411,    32,    32,    32,  -776,  -776,   494,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,    78,   551,   552,    66,    32,
      13,    14,  -776,  -776,  -776,  -776,  -776,   578,   430,   106,
     169,   464,  -776,    32,    32,    32,    32,   411,    32,   574,
    -776,  -776,   475,   411,    32,    32,   163,   163,   163,   163,
    -776,  -776,   411,   411,  -776,  -776,  -776,  -776,  -776,   411,
    -776,    32,  -776,  -776,    32,    32,    32,    32,    32,    32,
     411,    32,   554,    36,  -776,  -776,    32,  -776,  -776,  -776,
    -776,   576,   410,   581,  -776,   438,  -776,   106,  -776,  -776,
      32,  -776,   411,    32,  -776,   106,   411,    32,    32,   163,
     163,    32,    32,  -776,   411,  -776,    32,    32,    32,    32,
    -776,    32,    32,   556,  -776,    32,    32,    15,  -776,  -776,
    -776,   187,  -776,    32,  -776,   217,   411,  -776,  -776,    32,
      32,    32,    32,  -776,  -776,  -776,    32,  -776,    32,    32,
     559,    32,  -776,  -776,  -776,    18,  -776,  -776,  -776,   411,
      32,    32,    32,    32,  -776,  -776,    32,    32,  -776,    32,
     584,   106,   542,    32,    32,  -776,  -776,    32,  -776,  -776,
     245,   411,  -776,  -776,    32,    32,  -776,   538,  -776,   411,
      32,  -776
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,   203,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   205,   201,   202,   110,     0,   326,     3,    19,
     294,   215,   294,   196,     0,     0,   141,   142,   143,     0,
       0,     0,     0,     0,     0,   294,   294,   294,     0,     0,
     188,     0,   191,   193,   195,   190,   294,   294,     0,     0,
       0,     4,    17,    17,    17,    17,    32,    27,    28,    29,
      30,    31,    17,    17,    17,    17,    17,    17,    65,    67,
      68,    69,    70,    71,    72,    73,    74,    95,    92,    93,
      94,    91,    90,    75,    76,    78,    79,    81,    80,    82,
      84,    85,    87,    86,   100,   101,   102,   103,   104,   105,
     106,    89,    88,    77,    66,    83,    96,    97,    98,   107,
     108,    99,   109,    17,     0,     0,    21,    20,    22,     0,
       0,    33,     0,    50,    48,    46,    47,    45,    23,   206,
       0,    50,     0,     0,   216,   294,     0,   197,   294,     0,
       0,   294,   289,     0,     0,     0,   248,     0,     0,   200,
       0,     0,   245,     0,   178,   179,   211,   212,   213,   214,
     312,   308,   306,   307,     0,     0,     0,     0,     0,   189,
     236,   234,   235,   233,   261,     0,   299,   316,   318,   262,
     263,   264,   192,   194,     0,     0,   182,   183,     0,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   294,   294,     0,     0,     0,     0,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     294,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     294,   294,   294,   209,   327,   327,   327,   291,   294,     5,
       0,     0,     0,     0,     0,     0,    44,     0,    48,     0,
      61,   207,    48,   297,     0,     0,   282,     0,   217,   247,
       0,     0,     0,   248,   231,   232,   228,   230,   229,   273,
       0,     0,     0,   293,   196,     0,     0,     0,     0,   248,
       0,     0,   248,     0,   248,     0,   177,   219,   220,   273,
       0,     0,   243,   243,   218,     0,   309,   314,   313,   310,
     315,   320,   306,   307,     0,     0,   307,   304,   317,   319,
     286,   255,   268,     0,   321,   322,   323,   325,   324,     0,
       0,     0,     0,   298,     0,     0,     0,     7,     8,     9,
      10,    11,    12,    13,    15,    14,    16,     6,     0,     0,
       0,     0,     0,     0,   210,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,     0,     0,
     294,   294,   335,   294,     0,   294,   333,   333,   173,     0,
       0,   294,   328,   329,     0,     0,   292,   294,     0,    26,
       0,     0,     0,     0,     0,    43,    42,    51,    61,    49,
       0,    41,   208,     0,    61,     0,   295,     0,   282,     0,
     240,   239,   237,   238,   258,     0,     0,     0,   279,   273,
     164,     0,     0,   270,   271,   272,     0,     0,   287,     0,
       0,   248,     0,     0,   248,     0,     0,   248,     0,   248,
       0,     0,   169,     0,     0,   132,     0,   133,   131,   125,
     311,   305,     0,     0,     0,   259,   268,   303,   300,   301,
     302,   248,   248,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   294,     0,
     294,     0,     0,   294,   294,   198,   199,   172,     0,     0,
       0,   330,   331,   294,   294,     0,     0,     0,    61,    61,
      24,    24,    39,     0,   204,    40,     0,     0,     0,   124,
       0,     0,     0,   277,     0,   278,     0,     0,   265,   248,
       0,   288,     0,     0,   290,   248,   248,     0,     0,   248,
     249,   250,   161,     0,   248,     0,   253,   254,   169,   169,
       0,   306,     0,     0,   257,   256,     0,   260,   248,   153,
       0,     0,     0,     0,     0,   294,   294,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   248,   248,   336,   248,   248,     0,
       0,   334,     0,     0,     0,     0,     0,   332,     0,     0,
       0,   154,   248,    52,    36,    35,     0,    61,    61,    63,
     296,   283,     0,     0,     0,   134,   135,   280,   266,   276,
       0,     0,   163,     0,     0,   248,   248,   248,     0,   241,
     248,     0,   162,     0,   170,   171,   174,   246,     0,   306,
       0,   152,     0,     0,     0,   294,   294,     0,     0,   116,
     115,     0,     0,     0,     0,     0,     0,     0,   123,   117,
       0,   119,     0,     0,     0,   294,   248,   248,   248,   248,
       0,   248,   248,   248,   176,   175,   130,   129,   227,   226,
     224,   225,   221,   223,   222,   294,     0,     0,   157,   248,
       0,     0,    25,    37,    38,    62,    64,     0,     0,     0,
       0,     0,   281,   248,   248,   248,   248,     0,   248,     0,
     267,   244,     0,     0,   248,   248,     0,     0,     0,     0,
     112,   111,     0,     0,   126,   127,   128,   118,   120,     0,
     122,   248,   167,   168,   248,   248,   248,   248,   248,   248,
       0,   248,     0,     0,   155,   156,   248,    55,    54,    53,
      60,     0,    61,     0,   285,     0,   275,     0,   136,   137,
     248,   148,     0,   248,   242,     0,     0,   248,   248,     0,
       0,   248,   248,   113,     0,   121,   248,   248,   248,   248,
     139,   248,   248,     0,   251,   248,   248,     0,    34,   284,
     281,     0,   147,   248,   160,     0,     0,   180,   181,   248,
     248,   248,   248,   114,   165,   166,   248,   140,   248,   248,
       0,   150,   251,   158,    58,     0,   274,   146,   269,     0,
     248,   248,   248,   248,   138,   144,   248,   248,   252,   151,
       0,     0,     0,   248,   248,   186,   187,   248,   251,    59,
       0,     0,   184,   185,   248,   149,    57,     0,   145,     0,
     248,   159
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -776,  -776,   -15,  -776,   621,  -776,  -776,   133,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -151,   508,  -776,  -776,  -386,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,  -776,  -356,  -776,  -776,  -776,
    -776,  -776,  -776,  -776,  -776,   361,  -776,   272,  -776,  -776,
    -776,  -776,    43,   -29,  -776,  -776,  -776,   -68,  -776,   482,
    -394,  -776,  -776,  -776,   345,  -776,  -776,   128,  -775,   492,
    -776,  -250,    54,   -41,   -35,   -23,    59,    60,  -776,   202,
    -278,  -776,  -776,  -776,  -140,  -776,  -776,  -138,  -124,  -776,
    -776,  -776,  -776,  -170,   951,   255,  -776,  -161,  -776,   486,
     493,  -776,  -776,  -776,  -399,  -776,   -50,  -776,  -776,   289,
    -776
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   190,    51,   118,    52,    53,   597,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,   127,   250,   248,   681,   742,   391,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,   678,
      99,   100,   101,   102,   103,   104,   540,   105,   106,   107,
     108,   109,   110,   111,   112,   138,   487,   150,   113,   114,
     130,   393,   345,   262,   135,   257,   292,   286,   667,   263,
     169,   399,   145,   148,   435,   293,   258,   818,   801,   287,
     288,   170,   401,   264,   265,   266,   267,   268,   536,   445,
     412,   413,   414,   415,   269,   407,   515,   312,   404,   311,
     522,   276,   377,   141,   133,   255,   174,   175,   176,   177,
     178,   179,   180,   181,   323,   115,   373,   492,   588,   483,
     478
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     171,   272,   502,   305,   307,   509,   172,   400,   505,   259,
     289,   431,   168,   518,   737,   740,   804,   385,   173,   820,
     685,   261,   -56,   156,   157,   158,   159,   819,   253,   116,
     120,   261,   537,   340,   341,   342,   343,   741,   191,   192,
     193,   271,   261,   425,   285,   119,   117,   194,   195,   196,
     197,   198,   199,   835,   405,   261,   261,   121,   254,   125,
     485,   280,   281,   639,   386,   313,   314,   686,   315,   316,
     317,   166,   318,   821,   271,   538,   126,   486,   557,   559,
     398,   156,   157,   158,   159,   738,   271,   805,   -56,   -56,
     425,   319,   539,   320,   321,   322,   641,   388,   200,   296,
     297,   394,   122,   739,   280,   281,   160,   161,   162,   163,
     417,   123,   594,   595,   299,   300,   164,   608,   298,   124,
     289,   129,   409,   160,   161,   162,   306,   165,   132,   166,
     630,   516,   319,   164,   320,   321,   322,   408,   733,   281,
     299,   300,   301,   307,   304,   442,   443,   430,   302,   303,
     319,   134,   320,   430,   322,   137,   164,   140,   447,   448,
     449,   450,   156,   157,   158,   159,   131,   304,   525,   281,
     456,   457,   458,   459,   142,   446,   541,   303,   156,   157,
     158,   159,   624,   625,   164,   374,   375,   160,   161,   162,
     163,   139,   406,   144,   143,   304,   261,   164,   146,   147,
     154,   629,   303,   160,   161,   162,   163,   149,   165,   164,
     166,   683,   684,   164,   155,   746,   402,   182,   289,   666,
     304,   183,   403,   186,   165,   187,   166,   319,   168,   320,
     321,   322,   188,   806,   189,   167,   507,   239,   240,   704,
     705,   246,   247,   708,   709,   319,   249,   320,   321,   322,
     517,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   808,   251,   256,   319,   430,   320,   321,
     322,   271,   417,   273,   282,   319,   371,   320,   321,   322,
     275,   544,   545,   546,   734,   609,   553,   554,   555,   556,
     473,   836,   277,   278,   610,   611,   279,   319,   284,   320,
     321,   322,   324,   319,   291,   320,   321,   322,   295,   310,
     313,   325,   759,   760,   761,   762,   326,   327,   328,   344,
     289,   289,   289,   289,   289,   289,   289,   289,   289,   289,
     289,   289,   289,   289,   601,   329,   668,   330,   602,   331,
     332,   319,   333,   320,   321,   322,   334,   603,   335,   604,
     289,   336,   337,   607,   360,   359,   778,   362,   171,   613,
     364,   361,   363,   365,   172,   789,   790,   366,   601,   367,
     168,   372,   689,   376,   379,   319,   173,   320,   321,   322,
     380,   381,   417,   635,   636,   241,   242,   243,   244,   245,
     382,   410,   558,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   441,   424,   383,   387,
     427,   384,   429,   319,   389,   320,   321,   322,   390,   430,
     392,   430,   586,   395,   396,   397,   156,   157,   158,   159,
     156,   157,   158,   159,   314,   441,   315,   316,   317,   520,
     318,   688,   319,   411,   320,   321,   322,   420,   416,   690,
     691,   160,   161,   162,   163,   160,   161,   162,   163,   418,
     261,   164,   421,   422,   261,   164,   434,   423,   425,   702,
     426,   432,   165,   428,   440,   692,   165,   156,   157,   158,
     159,   744,   319,   167,   320,   321,   322,   436,   319,   780,
     320,   321,   322,   433,   444,   451,   319,   452,   320,   321,
     322,   453,   160,   161,   162,   163,   454,   477,   455,   474,
     520,   261,   510,   319,   480,   320,   321,   322,   491,   747,
     482,   493,   319,   165,   320,   321,   322,   494,   745,   496,
     755,   497,   498,   319,   167,   320,   321,   322,   499,   504,
     500,   501,   503,   253,   508,   670,   514,   521,   513,   526,
     523,   671,   529,   524,   528,   532,   527,   534,   530,   531,
     535,   542,   551,   672,   543,   552,   576,   573,   581,   584,
     585,   587,   592,   593,   621,   578,   580,   599,   591,   548,
     549,   623,   628,   600,   619,   596,   781,   626,   627,   633,
     634,   680,   171,   171,   785,   655,   171,   171,   172,   172,
     664,   660,   172,   172,   168,   168,   662,   663,   168,   168,
     173,   173,   665,   682,   173,   173,   687,   701,   675,   700,
     743,   777,   710,   731,   732,   754,   775,   779,   800,   283,
     829,   817,   128,   290,   598,   419,   839,   171,   438,   252,
     669,   831,   489,   172,   294,   673,   674,   612,   547,   168,
     506,   308,     0,   616,   617,   173,   484,   620,   309,     0,
     830,     0,   622,     0,     0,   171,   171,   171,   171,     0,
       0,   172,   172,   172,   172,     0,   631,   168,   168,   168,
     168,     0,     0,   173,   173,   173,   173,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   656,   657,     0,   658,   659,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   171,
     679,     0,     0,     0,   172,   172,     0,     0,     0,     0,
     168,   168,     0,     0,     0,     0,   173,   173,     0,     0,
       0,     0,     0,   694,   695,   696,     0,     0,   698,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   437,     0,   439,     0,     0,
       0,     0,     0,     0,   722,   723,   724,   725,     0,   727,
     728,   729,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   735,   736,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   748,   749,   750,   751,     0,   753,     0,     0,     0,
       0,     0,   757,   758,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   766,
       0,   488,   767,   768,   769,   770,   771,   772,     0,   774,
       0,     0,     0,     0,   776,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   782,     0,
       0,   784,     0,     0,     0,   787,   788,   511,   512,   791,
     792,     0,     0,     0,   794,   795,   796,   797,   519,   798,
     799,     0,     0,   802,   803,     0,     0,     0,     0,     0,
     533,   807,     0,     0,     0,     0,     0,   810,   811,   812,
     813,     0,     0,     0,   814,     0,   815,   816,     0,     0,
       0,     0,     0,     0,     0,   550,     0,     0,   823,   824,
     825,   826,     0,     0,   827,   828,     0,     0,     0,     0,
       0,   832,   833,     0,     0,   834,     0,   574,   575,     0,
       0,     0,   838,     0,     0,     0,     0,     0,   841,     0,
       0,     0,     0,   136,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   151,   152,   153,     0,
       0,     0,     0,   605,   606,     0,     0,   184,   185,     0,
       0,     0,     0,     0,   614,   615,     0,     0,     0,   618,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   632,     0,     0,     0,     0,     0,     0,     0,
     640,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,     0,     0,     0,     0,     0,
       0,     0,   661,     0,     0,     0,     0,     0,     0,     0,
       0,   676,   677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   260,     0,     0,   270,
       0,     0,   274,     0,     0,     0,   693,     0,     0,     0,
     697,     0,     0,   699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   703,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   711,   712,   713,   714,   715,   716,
       0,     0,   717,     0,   718,   719,   720,     0,     0,     0,
       0,     0,   726,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   338,   339,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   358,     0,     0,     0,     0,     0,     0,     0,   752,
       0,   368,   369,   370,     0,   756,     0,     0,     0,   378,
       0,     0,     0,     0,   763,   764,     0,     0,     0,     0,
       0,   765,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   773,     2,     0,     0,     3,     4,     0,     5,
       6,     0,     7,     8,     9,     0,    10,    11,     0,     0,
       0,     0,     0,     0,   783,     0,     0,     0,   786,     0,
       0,     0,     0,     0,     0,     0,   793,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,     0,    13,    14,     0,   809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    15,
      16,     0,     0,     0,     0,     0,     0,    17,    18,     0,
       0,   822,     0,     0,     0,     0,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,     0,
      19,   475,   476,   837,   479,     0,   481,    20,     0,     0,
       0,   840,   490,     0,     0,     0,     0,     0,   495,     0,
       0,     0,    21,    22,     0,     0,     0,     0,    23,    24,
      25,     0,     0,     0,    26,    27,    28,     0,     0,     0,
      29,    30,     0,    31,    32,    33,     0,     0,     0,    34,
      35,    36,    37,     0,    38,    39,    40,    41,    42,    43,
      44,    45,     0,     0,     0,    46,    47,     0,     0,    48,
      49,    50,     0,   201,   202,   203,   204,   205,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
       0,   579,     0,     0,   582,   583,     0,     0,     0,     0,
       0,     0,     0,     0,   589,   590,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,     0,     0,   221,
     222,   223,   224,     0,     0,     0,   225,   226,   227,     0,
       0,     0,     0,   228,   229,     0,     0,     0,     0,     0,
       0,   230,   231,   232,     0,     0,   637,   638,   233,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,   236,
       0,     0,   237,   238,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   706,   707,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   721,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   730
};

static const yytype_int16 yycheck[] =
{
      41,   139,   388,   164,   165,   399,    41,   257,   394,   133,
     150,   289,    41,   412,     1,     1,     1,    42,    41,     1,
      42,    49,     8,    15,    16,    17,    18,   802,    42,    72,
      72,    49,   431,   203,   204,   205,   206,    23,    53,    54,
      55,    50,    49,    54,    72,    42,    89,    62,    63,    64,
      65,    66,    67,   828,    72,    49,    49,    89,    72,    72,
      72,    72,    73,    72,    89,    72,    33,    89,    35,    36,
      37,    63,    39,    55,    50,    55,    89,    89,    72,    72,
      72,    15,    16,    17,    18,    72,    50,    72,    74,    75,
      54,    58,    72,    60,    61,    62,    72,   248,   113,    35,
      36,   252,    72,    90,    72,    73,    40,    41,    42,    43,
     271,    72,   498,   499,    35,    36,    50,   516,    54,    72,
     260,    65,   262,    40,    41,    42,    43,    61,    50,    63,
      56,   409,    58,    50,    60,    61,    62,   261,    72,    73,
      35,    36,    37,   304,    61,    60,    61,   285,    42,    43,
      58,    44,    60,   291,    62,    92,    50,    54,   319,   320,
     321,   322,    15,    16,    17,    18,    72,    61,    72,    73,
     340,   341,   342,   343,    93,   313,    42,    43,    15,    16,
      17,    18,   538,   539,    50,   235,   236,    40,    41,    42,
      43,    91,   260,    50,    93,    61,    49,    50,    72,    50,
      89,    42,    43,    40,    41,    42,    43,    72,    61,    50,
      63,   597,   598,    50,    42,    46,   257,   100,   358,    72,
      61,   100,   257,    72,    61,    72,    63,    58,   257,    60,
      61,    62,    93,    46,    74,    72,   397,    75,    54,   633,
     634,    59,    68,   637,   638,    58,    79,    60,    61,    62,
     411,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    46,    72,    72,    58,   405,    60,    61,
      62,    50,   433,    42,   146,    58,   233,    60,    61,    62,
      50,   442,   443,   444,   678,    46,   456,   457,   458,   459,
     358,    46,    95,    42,    55,    56,    72,    58,    72,    60,
      61,    62,    93,    58,    72,    60,    61,    62,    72,    72,
      72,    93,   706,   707,   708,   709,    72,    75,    75,    19,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,    51,    75,   586,    75,    55,    75,
      75,    58,    75,    60,    61,    62,    75,   508,    75,   510,
     490,    75,    75,   514,    93,    54,   742,    31,   399,   520,
      54,    93,    93,    93,   399,   759,   760,    31,    51,    31,
     399,    20,    55,    88,    42,    58,   399,    60,    61,    62,
      34,    77,   543,   553,   554,    83,    84,    85,    86,    87,
      77,   263,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,    51,   279,    77,    42,
     282,    77,   284,    58,    42,    60,    61,    62,     8,   557,
      70,   559,   490,    55,    51,    50,    15,    16,    17,    18,
      15,    16,    17,    18,    33,    51,    35,    36,    37,    55,
      39,   602,    58,    45,    60,    61,    62,    42,    72,   610,
     611,    40,    41,    42,    43,    40,    41,    42,    43,    72,
      49,    50,    72,    72,    49,    50,    72,    55,    54,   630,
      54,    50,    61,    55,    42,    51,    61,    15,    16,    17,
      18,    51,    58,    72,    60,    61,    62,    72,    58,    51,
      60,    61,    62,    50,    45,    72,    58,    72,    60,    61,
      62,    72,    40,    41,    42,    43,    43,    54,    43,    42,
      55,    49,    50,    58,    42,    60,    61,    62,    21,    55,
      54,    93,    58,    61,    60,    61,    62,    93,   689,    42,
      55,    77,    42,    58,    72,    60,    61,    62,    42,    51,
      42,    42,    72,    42,    50,   586,    55,    42,    48,   421,
      72,   586,   424,    51,    42,   427,    72,   429,    42,    42,
      45,    50,    42,   586,    50,    42,    42,    54,    42,    42,
      42,    22,    42,    42,    55,    72,    72,    59,    72,   451,
     452,    42,    42,    51,    51,    78,   747,    51,    51,    42,
      42,    24,   633,   634,   755,    42,   637,   638,   633,   634,
      42,    72,   637,   638,   633,   634,    72,    72,   637,   638,
     633,   634,    42,    72,   637,   638,    45,    51,    93,    46,
      42,    45,    72,    72,    72,    51,    72,    46,    72,   147,
      46,    72,    11,   151,   501,   274,    98,   678,   293,   131,
     586,    99,   370,   678,   152,   586,   586,   519,   446,   678,
     395,   165,    -1,   525,   526,   678,   367,   529,   165,    -1,
     821,    -1,   534,    -1,    -1,   706,   707,   708,   709,    -1,
      -1,   706,   707,   708,   709,    -1,   548,   706,   707,   708,
     709,    -1,    -1,   706,   707,   708,   709,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   574,   575,    -1,   577,   578,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   759,   760,
     592,    -1,    -1,    -1,   759,   760,    -1,    -1,    -1,    -1,
     759,   760,    -1,    -1,    -1,    -1,   759,   760,    -1,    -1,
      -1,    -1,    -1,   615,   616,   617,    -1,    -1,   620,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,   656,   657,   658,   659,    -1,   661,
     662,   663,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   678,   679,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   693,   694,   695,   696,    -1,   698,    -1,    -1,    -1,
      -1,    -1,   704,   705,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   721,
      -1,   369,   724,   725,   726,   727,   728,   729,    -1,   731,
      -1,    -1,    -1,    -1,   736,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   750,    -1,
      -1,   753,    -1,    -1,    -1,   757,   758,   405,   406,   761,
     762,    -1,    -1,    -1,   766,   767,   768,   769,   416,   771,
     772,    -1,    -1,   775,   776,    -1,    -1,    -1,    -1,    -1,
     428,   783,    -1,    -1,    -1,    -1,    -1,   789,   790,   791,
     792,    -1,    -1,    -1,   796,    -1,   798,   799,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   453,    -1,    -1,   810,   811,
     812,   813,    -1,    -1,   816,   817,    -1,    -1,    -1,    -1,
      -1,   823,   824,    -1,    -1,   827,    -1,   475,   476,    -1,
      -1,    -1,   834,    -1,    -1,    -1,    -1,    -1,   840,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    37,    -1,
      -1,    -1,    -1,   511,   512,    -1,    -1,    46,    47,    -1,
      -1,    -1,    -1,    -1,   522,   523,    -1,    -1,    -1,   527,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   550,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   589,   590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,   138,
      -1,    -1,   141,    -1,    -1,    -1,   614,    -1,    -1,    -1,
     618,    -1,    -1,   621,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   632,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   642,   643,   644,   645,   646,   647,
      -1,    -1,   650,    -1,   652,   653,   654,    -1,    -1,    -1,
      -1,    -1,   660,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   697,
      -1,   230,   231,   232,    -1,   703,    -1,    -1,    -1,   238,
      -1,    -1,    -1,    -1,   712,   713,    -1,    -1,    -1,    -1,
      -1,   719,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   730,     0,    -1,    -1,     3,     4,    -1,     6,
       7,    -1,     9,    10,    11,    -1,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   752,    -1,    -1,    -1,   756,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   764,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    52,    53,    -1,   786,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    -1,
      -1,   809,    -1,    -1,    -1,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
      97,   360,   361,   831,   363,    -1,   365,   104,    -1,    -1,
      -1,   839,   371,    -1,    -1,    -1,    -1,    -1,   377,    -1,
      -1,    -1,   119,   120,    -1,    -1,    -1,    -1,   125,   126,
     127,    -1,    -1,    -1,   131,   132,   133,    -1,    -1,    -1,
     137,   138,    -1,   140,   141,   142,    -1,    -1,    -1,   146,
     147,   148,   149,    -1,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,    -1,    -1,   162,   163,    -1,    -1,   166,
     167,   168,    -1,    25,    26,    27,    28,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,
      -1,   480,    -1,    -1,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,    -1,   121,
     122,   123,   124,    -1,    -1,    -1,   128,   129,   130,    -1,
      -1,    -1,    -1,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,   143,   144,   145,    -1,    -1,   555,   556,   150,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,   161,
      -1,    -1,   164,   165,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   635,   636,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   655,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   675
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   171,     0,     3,     4,     6,     7,     9,    10,    11,
      13,    14,    50,    52,    53,    66,    67,    74,    75,    97,
     104,   119,   120,   125,   126,   127,   131,   132,   133,   137,
     138,   140,   141,   142,   146,   147,   148,   149,   151,   152,
     153,   154,   155,   156,   157,   158,   162,   163,   166,   167,
     168,   173,   175,   176,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   230,
     231,   232,   233,   234,   235,   237,   238,   239,   240,   241,
     242,   243,   244,   248,   249,   305,    72,    89,   174,    42,
      72,    89,    72,    72,    72,    72,    89,   191,   174,    65,
     250,    72,    50,   294,    44,   254,   294,    92,   245,    91,
      54,   293,    93,    93,    50,   262,    72,    50,   263,    72,
     247,   294,   294,   294,    89,    42,    15,    16,    17,    18,
      40,    41,    42,    43,    50,    61,    63,    72,   253,   260,
     271,   273,   274,   275,   296,   297,   298,   299,   300,   301,
     302,   303,   100,   100,   294,   294,    72,    72,    93,    74,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,    25,    26,    27,    28,    29,    30,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   121,   122,   123,   124,   128,   129,   130,   135,   136,
     143,   144,   145,   150,   159,   160,   161,   164,   165,    75,
      54,    83,    84,    85,    86,    87,    59,    68,   193,    79,
     192,    72,   193,    42,    72,   295,    72,   255,   266,   288,
     294,    49,   253,   259,   273,   274,   275,   276,   277,   284,
     294,    50,   287,    42,   294,    50,   291,    95,    42,    72,
      72,    73,   267,   259,    72,    72,   257,   269,   270,   284,
     259,    72,   256,   265,   269,    72,    35,    36,    54,    35,
      36,    37,    42,    43,    61,   297,    43,   297,   299,   300,
      72,   289,   287,    72,    33,    35,    36,    37,    39,    58,
      60,    61,    62,   304,    93,    93,    72,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,   294,   294,
     293,   293,   293,   293,    19,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   294,    54,
      93,    93,    31,    93,    54,    93,    31,    31,   294,   294,
     294,   252,    20,   306,   306,   306,    88,   292,   294,    42,
      34,    77,    77,    77,    77,    42,    89,    42,   192,    42,
       8,   196,    70,   251,   192,    55,    51,    50,    72,   261,
     271,   272,   273,   274,   288,    72,   257,   285,   288,   284,
     267,    45,   280,   281,   282,   283,    72,   297,    72,   245,
      42,    72,    72,    55,   267,    54,    54,   267,    55,   267,
     287,   280,    50,    50,    72,   264,    72,   259,   264,   259,
      42,    51,    60,    61,    45,   279,   287,   297,   297,   297,
     297,    72,    72,    72,    43,    43,   293,   293,   293,   293,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   257,    42,   294,   294,    54,   310,   294,
      42,   294,    54,   309,   309,    72,    89,   246,   259,   247,
     294,    21,   307,    93,    93,   294,    42,    77,    42,    42,
      42,    42,   196,    72,    51,   196,   295,   297,    50,   260,
      50,   259,   259,    48,    55,   286,   280,   297,   304,   259,
      55,    42,   290,    72,    51,    72,   267,    72,    42,   267,
      42,    42,   267,   259,   267,    45,   278,   304,    55,    72,
     236,    42,    50,    50,   297,   297,   297,   279,   267,   267,
     259,    42,    42,   293,   293,   293,   293,    72,   257,    72,
     257,   257,   257,   257,   257,   257,   257,   257,   257,   257,
     257,   257,   257,    54,   259,   259,    42,   294,    72,   294,
      72,    42,   294,   294,    42,    42,   257,    22,   308,   294,
     294,    72,    42,    42,   196,   196,    78,   177,   177,    59,
      51,    51,    55,   297,   297,   259,   259,   297,   304,    46,
      55,    56,   267,   297,   259,   259,   267,   267,   259,    51,
     267,    55,   267,    42,   236,   236,    51,    51,    42,    42,
      56,   267,   259,    42,    42,   293,   293,   294,   294,    72,
     259,    72,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   259,    42,   267,   267,   267,   267,
      72,   259,    72,    72,    42,    42,    72,   258,   271,   272,
     273,   274,   275,   276,   277,    93,   259,   259,   229,   267,
      24,   194,    72,   196,   196,    42,    89,    45,   297,    55,
     297,   297,    51,   259,   267,   267,   267,   259,   267,   259,
      46,    51,   297,   259,   260,   260,   294,   294,   260,   260,
      72,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   294,   267,   267,   267,   267,   259,   267,   267,   267,
     294,    72,    72,    72,   260,   267,   267,     1,    72,    90,
       1,    23,   195,    42,    51,   297,    46,    55,   267,   267,
     267,   267,   259,   267,    51,    55,   259,   267,   267,   260,
     260,   260,   260,   259,   259,   259,   267,   267,   267,   267,
     267,   267,   267,   259,   267,    72,   267,    45,   196,    46,
      51,   297,   267,   259,   267,   297,   259,   267,   267,   260,
     260,   267,   267,   259,   267,   267,   267,   267,   267,   267,
      72,   268,   267,   267,     1,    72,    46,   267,    46,   259,
     267,   267,   267,   267,   267,   267,   267,    72,   267,   268,
       1,    55,   259,   267,   267,   267,   267,   267,   267,    46,
     297,    99,   267,   267,   267,   268,    46,   259,   267,    98,
     259,   267
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   170,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   171,   171,   171,   171,   171,   171,   172,   172,   173,
     174,   174,   175,   176,   177,   177,   178,   179,   179,   179,
     179,   179,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   189,   189,   190,   191,   191,   192,   192,
     193,   193,   194,   194,   194,   194,   195,   195,   195,   195,
     195,   196,   196,   196,   196,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
     197,   198,   198,   198,   198,   199,   199,   200,   201,   202,
     203,   204,   204,   205,   206,   207,   208,   209,   210,   211,
     211,   212,   212,   212,   213,   213,   214,   215,   216,   217,
     218,   219,   219,   219,   220,   221,   222,   223,   223,   224,
     225,   226,   227,   228,   229,   229,   229,   230,   231,   232,
     233,   233,   233,   234,   235,   235,   235,   235,   235,   236,
     236,   236,   237,   237,   237,   237,   237,   237,   238,   239,
     240,   240,   241,   242,   243,   243,   243,   243,   244,   244,
     244,   244,   244,   244,   244,   244,   245,   245,   246,   246,
     247,   248,   248,   249,   249,   250,   250,   251,   251,   252,
     252,   253,   253,   253,   253,   254,   254,   255,   256,   257,
     257,   258,   258,   258,   258,   258,   258,   258,   259,   259,
     259,   259,   259,   260,   260,   260,   260,   261,   261,   261,
     261,   262,   263,   264,   264,   265,   265,   266,   267,   267,
     267,   268,   268,   269,   270,   271,   271,   271,   272,   273,
     274,   275,   275,   275,   275,   276,   277,   278,   279,   279,
     280,   280,   280,   281,   281,   282,   283,   284,   285,   286,
     286,   287,   288,   288,   288,   288,   289,   290,   290,   291,
     291,   292,   292,   293,   294,   294,   294,   295,   296,   297,
     297,   297,   297,   297,   297,   297,   298,   298,   299,   299,
     299,   300,   300,   300,   300,   300,   301,   301,   302,   302,
     303,   304,   304,   304,   304,   304,   305,   306,   306,   307,
     307,   308,   308,   309,   309,   310,   310
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     3,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     0,     1,     1,
       1,     1,     2,     2,     0,     2,     4,     1,     1,     1,
       1,     1,     1,     2,     9,     6,     6,     7,     7,     5,
       5,     4,     4,     4,     3,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     2,     2,     0,     6,     3,     5,
       1,     0,     4,     3,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     7,     7,     8,     9,     6,     6,     6,     7,     6,
       7,     8,     7,     6,     5,     4,     7,     7,     7,     6,
       6,     4,     4,     4,     6,     6,     8,     8,    10,     8,
       9,     1,     1,     1,    10,    13,    10,     9,     8,    12,
       9,    10,     6,     5,     0,     2,     2,     6,     9,    16,
       9,     5,     6,     6,     4,     9,     9,     7,     7,     0,
       2,     2,     4,     3,     6,     6,     6,     3,     2,     2,
       9,     9,     2,     2,    12,    12,    11,    11,     1,     2,
       1,     1,     2,     1,     2,     1,     0,     1,     1,     1,
       1,     1,     1,     0,     5,     0,     1,     0,     1,     0,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     7,     0,     4,     0,     4,     1,     0,     3,
       3,     0,     2,     3,     3,     2,     4,     4,     1,     3,
       4,     1,     1,     1,     1,     3,     4,     3,     0,     7,
       1,     1,     1,     0,     7,     5,     3,     3,     2,     0,
       2,     5,     1,     4,     7,     6,     1,     0,     1,     0,
       3,     0,     1,     2,     0,     3,     5,     1,     2,     1,
       3,     3,     3,     3,     2,     3,     1,     1,     1,     2,
       2,     3,     1,     2,     2,     2,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     0,     1,     0,
       1,     0,     1,     0,     2,     0,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pCisaBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, pCisaBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pCisaBuilder)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (pCisaBuilder);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pCisaBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep, pCisaBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, CISA_IR_Builder* pCisaBuilder)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              , pCisaBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pCisaBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, CISA_IR_Builder* pCisaBuilder)
{
  YYUSE (yyvaluep);
  YYUSE (pCisaBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pCisaBuilder)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 17:
#line 555 "CISA.y"
    {
                    //TODO add comments
                  //pBuilder->addTrailingComment("No comment");
              }
#line 2419 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 18:
#line 560 "CISA.y"
    {
                    //TODO add comments
                  //pBuilder->addTrailingComment($1);
              }
#line 2428 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 19:
#line 566 "CISA.y"
    {
                 pCisaBuilder->CISA_post_file_parse();
             }
#line 2436 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 22:
#line 578 "CISA.y"
    {
                  VISAKernel *cisa_kernel = NULL;
                  pCisaBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
              }
#line 2445 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 23:
#line 586 "CISA.y"
    {
                  VISAFunction *cisa_kernel = NULL;
                  pCisaBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
              }
#line 2454 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 24:
#line 592 "CISA.y"
    {(yyval.string) = "";}
#line 2460 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 25:
#line 593 "CISA.y"
    {(yyval.string) = (yyvsp[0].string);}
#line 2466 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 26:
#line 598 "CISA.y"
    {
       pCisaBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].number), (unsigned char)(yyvsp[0].number));
   }
#line 2474 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 33:
#line 611 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 2482 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 34:
#line 617 "CISA.y"
    {
                   attr_gen_struct temp_struct;
                   temp_struct.value = (yyvsp[0].attr_gen).value;
                   temp_struct.name = (yyvsp[0].attr_gen).name;
                   temp_struct.string_val = (yyvsp[0].attr_gen).string_val;
                   temp_struct.isInt = (yyvsp[0].attr_gen).isInt;
                   temp_struct.attr_set = (yyvsp[0].attr_gen).attr_set;
                   if (!pCisaBuilder->CISA_general_variable_decl((yyvsp[-7].string), (unsigned int)(yyvsp[-3].number), (yyvsp[-5].type), (yyvsp[-2].CISA_align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, temp_struct, CISAlineno)) {
                       YYABORT; // error already reported
                   }
               }
#line 2498 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 35:
#line 631 "CISA.y"
    {
                   attr_gen_struct temp_struct;
                   temp_struct.value = (yyvsp[0].attr_gen).value;
                   temp_struct.name = (yyvsp[0].attr_gen).name;
                   temp_struct.string_val = (yyvsp[0].attr_gen).string_val;
                   temp_struct.isInt = (yyvsp[0].attr_gen).isInt;
                   temp_struct.attr_set = (yyvsp[0].attr_gen).attr_set;
                   pCisaBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].number), ISA_TYPE_UW, temp_struct, CISAlineno);
               }
#line 2512 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 36:
#line 643 "CISA.y"
    {
                   attr_gen_struct temp_struct;
                   temp_struct.value = (yyvsp[0].attr_gen).value;
                   temp_struct.name = (yyvsp[0].attr_gen).name;
                   temp_struct.string_val = (yyvsp[0].attr_gen).string_val;
                   temp_struct.isInt = (yyvsp[0].attr_gen).isInt;
                   temp_struct.attr_set = (yyvsp[0].attr_gen).attr_set;
                   if (!pCisaBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].number), temp_struct, CISAlineno)) {
                       YYABORT; // error already reported
                   }
               }
#line 2528 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 37:
#line 657 "CISA.y"
    {
                   if (!pCisaBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].number), (yyvsp[-1].string), CISAlineno)) {
                       YYABORT; // error already reported
                   }
               }
#line 2538 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 38:
#line 665 "CISA.y"
    {
                   attr_gen_struct temp_struct;
                   temp_struct.value = (yyvsp[0].attr_gen).value;
                   temp_struct.name = (yyvsp[0].attr_gen).name;
                   temp_struct.string_val = (yyvsp[0].attr_gen).string_val;
                   temp_struct.isInt = (yyvsp[0].attr_gen).isInt;
                   temp_struct.attr_set = (yyvsp[0].attr_gen).attr_set;
                   if (!pCisaBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].number), (yyvsp[-1].string), temp_struct, CISAlineno)) {
                       YYABORT; // error already reported
                   }
               }
#line 2554 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 39:
#line 680 "CISA.y"
    {
                   pCisaBuilder->CISA_input_directive((yyvsp[-3].string), (short)(yyvsp[-2].number), (unsigned short)(yyvsp[-1].number), CISAlineno);
               }
#line 2562 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 40:
#line 687 "CISA.y"
    {
                   pCisaBuilder->CISA_implicit_input_directive((yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].number), (unsigned short)(yyvsp[-1].number), CISAlineno);
               }
#line 2570 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 41:
#line 694 "CISA.y"
    {
                   pCisaBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].number), CISAlineno);
               }
#line 2578 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 42:
#line 699 "CISA.y"
    {
                   pCisaBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno);
               }
#line 2586 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 43:
#line 702 "CISA.y"
    {
                   pCisaBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].number), CISAlineno);
               }
#line 2594 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 44:
#line 705 "CISA.y"
    {
                   pCisaBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno);
               }
#line 2602 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 45:
#line 712 "CISA.y"
    {
                   pCisaBuilder->CISA_function_directive((yyvsp[0].string));
               }
#line 2610 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 46:
#line 716 "CISA.y"
    {(yyval.string) = (yyvsp[0].string);}
#line 2616 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 47:
#line 717 "CISA.y"
    {(yyval.string) = (yyvsp[0].string);}
#line 2622 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 48:
#line 720 "CISA.y"
    {(yyval.number) = 1;}
#line 2628 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 49:
#line 722 "CISA.y"
    {(yyval.number) = (yyvsp[0].number);}
#line 2634 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 50:
#line 725 "CISA.y"
    {(yyval.number) = 0;}
#line 2640 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 51:
#line 727 "CISA.y"
    {(yyval.number) = (yyvsp[0].number);}
#line 2646 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 52:
#line 730 "CISA.y"
    {
                   (yyval.CISA_align) = ALIGN_BYTE;
               }
#line 2654 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 53:
#line 733 "CISA.y"
    {
                   (yyval.CISA_align) = ALIGN_BYTE;
              }
#line 2662 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 54:
#line 737 "CISA.y"
    {
                   if (!ParseAlign(pCisaBuilder, (yyvsp[0].string), (yyval.CISA_align))) {
                       PARSE_ERROR((yyvsp[0].string), ": invalid ALIGN");
                   }
               }
#line 2672 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 55:
#line 743 "CISA.y"
    {
                   PARSE_ERROR("syntax error in align attribute");
               }
#line 2680 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 56:
#line 748 "CISA.y"
    {
                   (yyval.alias).aliasname = NULL;
                   (yyval.alias).offset = 0;
               }
#line 2689 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 57:
#line 753 "CISA.y"
    {
                   (yyval.alias).aliasname = (yyvsp[-3].string);
                   (yyval.alias).offset = (int)(yyvsp[-1].number);
               }
#line 2698 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 58:
#line 758 "CISA.y"
    {
                   PARSE_ERROR("syntax error in alias attribute");
               }
#line 2706 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 59:
#line 762 "CISA.y"
    {
                   PARSE_ERROR("syntax error in alias attribute");
                   YYABORT; // bail out
               }
#line 2715 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 60:
#line 767 "CISA.y"
    {
                   PARSE_ERROR("syntax error in alias attribute");
                   YYABORT; // bail out
               }
#line 2724 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 61:
#line 773 "CISA.y"
    {
                (yyval.attr_gen).name = "";
                (yyval.attr_gen).value = 0;
                (yyval.attr_gen).attr_set = false;
            }
#line 2734 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 62:
#line 779 "CISA.y"
    {
              (yyval.attr_gen).name = (yyvsp[-2].string);
              (yyval.attr_gen).isInt = true;
              (yyval.attr_gen).value = (int)(yyvsp[0].number);
              (yyval.attr_gen).attr_set = true;
            }
#line 2745 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 63:
#line 786 "CISA.y"
    {
              (yyval.attr_gen).name = (yyvsp[-1].string);
              (yyval.attr_gen).isInt = false;
              (yyval.attr_gen).string_val = "";
              (yyval.attr_gen).attr_set = true;
            }
#line 2756 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 64:
#line 794 "CISA.y"
    {
              (yyval.attr_gen).name = (yyvsp[-2].string);
              (yyval.attr_gen).isInt = false;
              (yyval.attr_gen).string_val = (yyvsp[0].string);
              (yyval.attr_gen).attr_set = true;
            }
#line 2767 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 110:
#line 851 "CISA.y"
    {
             pCisaBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);
         }
#line 2775 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 111:
#line 858 "CISA.y"
    {
             pCisaBuilder->CISA_create_logic_instruction((yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
         }
#line 2783 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 112:
#line 862 "CISA.y"
    {
             pCisaBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].string), (yyvsp[0].string), CISAlineno);
         }
#line 2791 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 113:
#line 866 "CISA.y"
    {
             pCisaBuilder->CISA_create_logic_instruction((yyvsp[-7].cisa_pred).cisa_gen_opnd, (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
         }
#line 2799 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 114:
#line 870 "CISA.y"
    {
             pCisaBuilder->CISA_create_logic_instruction((yyvsp[-8].cisa_pred).cisa_gen_opnd, (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2807 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 115:
#line 876 "CISA.y"
    {
             pCisaBuilder->CISA_create_logic_instruction((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
         }
#line 2815 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 116:
#line 880 "CISA.y"
    {
             pCisaBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string), (yyvsp[0].string), NULL, CISAlineno);
         }
#line 2823 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 117:
#line 886 "CISA.y"
    {
             pCisaBuilder->CISA_create_math_instruction((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
         }
#line 2831 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 118:
#line 892 "CISA.y"
    {
             pCisaBuilder->CISA_create_math_instruction((yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2839 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 119:
#line 898 "CISA.y"
    {
             //pBuilder->CISA_create_arith_instruction($1, $2, $3, $4.emask, $4.exec_size, $5.opnd, $6.opnd, NULL, NULL, CISAlineno);
             pCisaBuilder->CISA_create_arith_instruction((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
         }
#line 2848 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 120:
#line 905 "CISA.y"
    {
             MUST_BE_TRUE1(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)), CISAlineno, "Wrong type of first src operand for LINE instruction");
             //pBuilder->CISA_create_arith_instruction($1, $2, $3, $4.emask, $4.exec_size, $5.opnd, $6.opnd, $7.opnd, NULL, CISAlineno);
             pCisaBuilder->CISA_create_arith_instruction((yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
         }
#line 2858 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 121:
#line 913 "CISA.y"
    {
             //pBuilder->CISA_create_arith_instruction($1, $2, $3, $4.emask, $4.exec_size, $5.opnd, $6.opnd, $7.opnd, $8.opnd, CISAlineno);
             pCisaBuilder->CISA_create_arith_instruction((yyvsp[-7].cisa_pred).cisa_gen_opnd, (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2867 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 122:
#line 919 "CISA.y"
    {
            pCisaBuilder->CISA_create_arith_instruction2((yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2875 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 123:
#line 926 "CISA.y"
    {
             pCisaBuilder->CISA_create_invtri_inst((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2883 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 124:
#line 932 "CISA.y"
    {
             pCisaBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2891 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 125:
#line 938 "CISA.y"
    {
             pCisaBuilder->CISA_create_setp_instruction((yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2899 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 126:
#line 944 "CISA.y"
    {
             pCisaBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2907 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 127:
#line 950 "CISA.y"
    {
             pCisaBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2915 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 128:
#line 956 "CISA.y"
    {
             pCisaBuilder->CISA_create_fminmax_instruction(1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2923 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 129:
#line 962 "CISA.y"
    {
             pCisaBuilder->CISA_create_mov_instruction((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2931 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 130:
#line 966 "CISA.y"
    {
             pCisaBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].string), CISAlineno);
         }
#line 2939 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 131:
#line 972 "CISA.y"
    {
             pCisaBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
         }
#line 2947 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 132:
#line 976 "CISA.y"
    {
           pCisaBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
         }
#line 2955 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 133:
#line 980 "CISA.y"
    {
           pCisaBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2963 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 134:
#line 986 "CISA.y"
    {
             pCisaBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod).cisa_mod, ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2971 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 135:
#line 991 "CISA.y"
    {
             pCisaBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod).cisa_mod, ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 2979 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 136:
#line 996 "CISA.y"
    {
             pCisaBuilder->CISA_create_media_instruction((yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].number), (yyvsp[-4].string), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
         }
#line 2987 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 137:
#line 1002 "CISA.y"
    {
             pCisaBuilder->CISA_create_scatter_instruction((yyvsp[-7].opcode), (int) (yyvsp[-6].number), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 2995 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 138:
#line 1008 "CISA.y"
    {
            pCisaBuilder->CISA_create_scatter4_typed_instruction((yyvsp[-8].opcode), (yyvsp[-9].cisa_pred).cisa_gen_opnd, ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string), (yyvsp[-4].RawVar).cisa_gen_opnd, (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3003 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 139:
#line 1014 "CISA.y"
    {
            pCisaBuilder->CISA_create_scatter4_scaled_instruction((yyvsp[-6].opcode), (yyvsp[-7].cisa_pred).cisa_gen_opnd, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3011 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 140:
#line 1020 "CISA.y"
    {
            pCisaBuilder->CISA_create_scatter_scaled_instruction((yyvsp[-7].opcode), (yyvsp[-8].cisa_pred).cisa_gen_opnd, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].number), (yyvsp[-3].string), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3019 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 141:
#line 1026 "CISA.y"
    {
                pCisaBuilder->CISA_create_sync_instruction((yyvsp[0].opcode));
            }
#line 3027 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 142:
#line 1030 "CISA.y"
    {
                pCisaBuilder->CISA_create_sbarrier_instruction(true);
            }
#line 3035 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 143:
#line 1034 "CISA.y"
    {
                pCisaBuilder->CISA_create_sbarrier_instruction(false);
            }
#line 3043 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 144:
#line 1040 "CISA.y"
    {
        pCisaBuilder->CISA_create_dword_atomic_instruction((yyvsp[-9].cisa_pred).cisa_gen_opnd, (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
    }
#line 3051 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 145:
#line 1046 "CISA.y"
    {
        pCisaBuilder->CISA_create_typed_atomic_instruction((yyvsp[-12].cisa_pred).cisa_gen_opnd, (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
        (yyvsp[-6].RawVar).cisa_gen_opnd, (yyvsp[-5].RawVar).cisa_gen_opnd, (yyvsp[-4].RawVar).cisa_gen_opnd, (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
    }
#line 3060 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 146:
#line 1053 "CISA.y"
    {
              pCisaBuilder->CISA_create_sampleunorm_instruction((yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string), (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
           }
#line 3068 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 147:
#line 1059 "CISA.y"
    {
               pCisaBuilder->CISA_create_sample_instruction((yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].number), (yyvsp[-5].string), (yyvsp[-4].string), (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
           }
#line 3076 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 148:
#line 1065 "CISA.y"
    {
               pCisaBuilder->CISA_create_sample_instruction((yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].number), "", (yyvsp[-4].string), (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
           }
#line 3084 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 149:
#line 1071 "CISA.y"
    {
               pCisaBuilder->create3DSampleInstruction( (yyvsp[-11].cisa_pred).cisa_gen_opnd, (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string), (yyvsp[-1].RawVar).cisa_gen_opnd, (unsigned int) (yyvsp[0].number), rawOperandArray, CISAlineno);
           }
#line 3092 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 150:
#line 1077 "CISA.y"
    {
               pCisaBuilder->create3DLoadInstruction( (yyvsp[-8].cisa_pred).cisa_gen_opnd, (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string), (yyvsp[-1].RawVar).cisa_gen_opnd, (unsigned int) (yyvsp[0].number), rawOperandArray, CISAlineno);
           }
#line 3100 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 151:
#line 1083 "CISA.y"
    {
              pCisaBuilder->createSample4Instruction( (yyvsp[-9].cisa_pred).cisa_gen_opnd, (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string), (yyvsp[-1].RawVar).cisa_gen_opnd, (unsigned int) (yyvsp[0].number), rawOperandArray, CISAlineno );
           }
#line 3108 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 152:
#line 1089 "CISA.y"
    {
                pCisaBuilder->CISA_create_info_3d_instruction( VISA_3D_RESINFO, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno );
           }
#line 3116 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 153:
#line 1095 "CISA.y"
    {
                pCisaBuilder->CISA_create_info_3d_instruction( VISA_3D_SAMPLEINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-2].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno );
           }
#line 3124 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 154:
#line 1100 "CISA.y"
    {
            }
#line 3131 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 155:
#line 1103 "CISA.y"
    {
                RTWriteOperands.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
            }
#line 3139 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 156:
#line 1107 "CISA.y"
    {
                RTWriteOperands.push_back((yyvsp[0].RawVar).cisa_gen_opnd);
            }
#line 3147 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 157:
#line 1112 "CISA.y"
    {
               pCisaBuilder->CISA_create_rtwrite_3d_instruction( (yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
                                                                  RTWriteOperands, CISAlineno );
               RTWriteOperands.clear();
           }
#line 3157 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 158:
#line 1120 "CISA.y"
    {
               pCisaBuilder->CISA_create_urb_write_3d_instruction( (yyvsp[-8].cisa_pred).cisa_gen_opnd, (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].number), (unsigned int)(yyvsp[-4].number), (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno );
           }
#line 3165 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 159:
#line 1126 "CISA.y"
    {
               pCisaBuilder->CISA_create_avs_instruction(ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string), (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd, (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
           }
#line 3173 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 160:
#line 1134 "CISA.y"
    {
           /*
                1 - OP
                2 - StreamMode, SearchCtrl
                3 - Surface
                4 - UNIInput
                5 - IMEInput
                6 - ref0
                7 - ref1
                8 - CostCenter
                9 - Output
           */
                pCisaBuilder->CISA_create_vme_ime_instruction((yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar).cisa_gen_opnd, (yyvsp[-4].RawVar).cisa_gen_opnd, (yyvsp[-6].string),
                    (yyvsp[-3].RawVar).cisa_gen_opnd,(yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
           }
#line 3193 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 161:
#line 1152 "CISA.y"
    {
                pCisaBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
           }
#line 3201 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 162:
#line 1158 "CISA.y"
    {
                /*
                    1 - OP
                    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
                    3 - surface
                    4 - UNIInput
                    5 - FBRInput
                    6 - output
                */
                pCisaBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[-3].string),
                    (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
             }
#line 3218 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 163:
#line 1173 "CISA.y"
    {
             pCisaBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
         }
#line 3226 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 164:
#line 1180 "CISA.y"
    {
    pCisaBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, false/*unaligned*/, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
}
#line 3234 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 165:
#line 1185 "CISA.y"
    {
    pCisaBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].cisa_pred).cisa_gen_opnd, (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].number), (unsigned int)(yyvsp[-3].number), (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
}
#line 3242 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 166:
#line 1190 "CISA.y"
    {
    pCisaBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].cisa_pred).cisa_gen_opnd, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (yyvsp[-5].ushortnum), (yyvsp[-3].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, CISAlineno);
}
#line 3250 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 167:
#line 1195 "CISA.y"
    {
    pCisaBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
}
#line 3258 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 168:
#line 1200 "CISA.y"
    {
    pCisaBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].cisa_pred).cisa_gen_opnd, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
}
#line 3266 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 169:
#line 1206 "CISA.y"
    {
                (yyval.number) = 0;
               }
#line 3274 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 170:
#line 1210 "CISA.y"
    {
                (yyval.number) = (yyvsp[0].number);
               }
#line 3282 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 171:
#line 1214 "CISA.y"
    {
                    switch_label_array[(yyvsp[0].number)++] = (yyvsp[-1].string);
                    (yyval.number) = (yyvsp[0].number);
               }
#line 3291 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 172:
#line 1221 "CISA.y"
    {
             pCisaBuilder->CISA_create_branch_instruction((yyvsp[-3].cisa_pred).cisa_gen_opnd, (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), CISAlineno);
         }
#line 3299 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 173:
#line 1225 "CISA.y"
    {
             pCisaBuilder->CISA_Create_Ret((yyvsp[-2].cisa_pred).cisa_gen_opnd, (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
         }
#line 3307 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 174:
#line 1229 "CISA.y"
    {
            pCisaBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (int)(yyvsp[-1].number), switch_label_array, CISAlineno);
         }
#line 3315 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 175:
#line 1234 "CISA.y"
    {
            pCisaBuilder->CISA_create_fcall_instruction((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].number), (unsigned)(yyvsp[0].number), CISAlineno);
         }
#line 3323 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 176:
#line 1239 "CISA.y"
    {
            pCisaBuilder->CISA_create_ifcall_instruction((yyvsp[-5].cisa_pred).cisa_gen_opnd, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].number), (unsigned)(yyvsp[0].number), CISAlineno);
         }
#line 3332 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 177:
#line 1245 "CISA.y"
    {
            pCisaBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
         }
#line 3340 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 178:
#line 1251 "CISA.y"
    {
            pCisaBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string));
        }
#line 3348 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 179:
#line 1256 "CISA.y"
    {
            pCisaBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].number));
        }
#line 3356 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 180:
#line 1261 "CISA.y"
    {
            pCisaBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].cisa_pred).cisa_gen_opnd, (unsigned)(yyvsp[-5].number), (unsigned char)(yyvsp[-4].number), (unsigned char)(yyvsp[-3].number), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3364 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 181:
#line 1266 "CISA.y"
    {
            pCisaBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].cisa_pred).cisa_gen_opnd, (unsigned)(yyvsp[-5].number), (unsigned char)(yyvsp[-4].number), (unsigned char)(yyvsp[-3].number), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3372 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 182:
#line 1272 "CISA.y"
    {
            pCisaBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno);
        }
#line 3380 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 183:
#line 1278 "CISA.y"
    {
            pCisaBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno);
        }
#line 3388 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 184:
#line 1283 "CISA.y"
    {
            pCisaBuilder->CISA_create_raw_sends_instruction(ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].cisa_pred).cisa_gen_opnd, (yyvsp[-4].genOperand).cisa_gen_opnd, (unsigned char)(yyvsp[-9].number), (unsigned char)(yyvsp[-8].number),
                (unsigned char)(yyvsp[-7].number), (unsigned char)(yyvsp[-6].number), (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3397 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 185:
#line 1289 "CISA.y"
    {
            pCisaBuilder->CISA_create_raw_sends_instruction(ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].cisa_pred).cisa_gen_opnd, (yyvsp[-4].genOperand).cisa_gen_opnd, (unsigned char)(yyvsp[-9].number), (unsigned char)(yyvsp[-8].number),
                (unsigned char)(yyvsp[-7].number), (unsigned char)(yyvsp[-6].number), (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3406 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 186:
#line 1295 "CISA.y"
    {
            pCisaBuilder->CISA_create_raw_sends_instruction(ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].cisa_pred).cisa_gen_opnd, (yyvsp[-4].genOperand).cisa_gen_opnd, 0, (unsigned char)(yyvsp[-8].number),
                (unsigned char)(yyvsp[-7].number), (unsigned char)(yyvsp[-6].number), (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3415 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 187:
#line 1301 "CISA.y"
    {
            pCisaBuilder->CISA_create_raw_sends_instruction(ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].cisa_pred).cisa_gen_opnd, (yyvsp[-4].genOperand).cisa_gen_opnd, 0, (unsigned char)(yyvsp[-8].number),
                (unsigned char)(yyvsp[-7].number), (unsigned char)(yyvsp[-6].number), (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar).cisa_gen_opnd, (yyvsp[-1].RawVar).cisa_gen_opnd, (yyvsp[0].RawVar).cisa_gen_opnd, CISAlineno);
        }
#line 3424 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 188:
#line 1307 "CISA.y"
    {
                pCisaBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode));
              }
#line 3432 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 189:
#line 1311 "CISA.y"
    {
                pCisaBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd);
              }
#line 3440 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 190:
#line 1315 "CISA.y"
    {
                  pCisaBuilder->CISA_create_yield_instruction((yyvsp[0].opcode));
              }
#line 3448 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 191:
#line 1319 "CISA.y"
    {
                    pCisaBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0);
              }
#line 3456 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 192:
#line 1323 "CISA.y"
    {
                    pCisaBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options));
              }
#line 3464 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 193:
#line 1327 "CISA.y"
    {
                    pCisaBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20);
              }
#line 3472 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 194:
#line 1331 "CISA.y"
    {
                    pCisaBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20);
              }
#line 3480 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 195:
#line 1335 "CISA.y"
    {
                    pCisaBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80);
              }
#line 3488 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 196:
#line 1341 "CISA.y"
    {(yyval.oword_mod) = false;}
#line 3494 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 197:
#line 1343 "CISA.y"
    {(yyval.oword_mod) = (yyvsp[0].oword_mod);}
#line 3500 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 198:
#line 1346 "CISA.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3506 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 199:
#line 1348 "CISA.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3512 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 200:
#line 1351 "CISA.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3518 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 201:
#line 1356 "CISA.y"
    {
        pCisaBuilder->CISA_push_decl_scope();
    }
#line 3526 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 202:
#line 1360 "CISA.y"
    {
        pCisaBuilder->CISA_pop_decl_scope();
    }
#line 3534 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 203:
#line 1367 "CISA.y"
    {
             (yyval.cisa_pred).cisa_gen_opnd = NULL;
            }
#line 3542 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 204:
#line 1371 "CISA.y"
    {
                char upppered[20];  //FIXME, there should be single name in the dumpling, lower/Upper changes should not be allowed.
                int str_len = strlen((yyvsp[-2].string));
                for (int i = 0; i < str_len; i++) {
                    upppered[i] = toupper((yyvsp[-2].string)[i]);
                }
                upppered[str_len]='\0';
                (yyval.cisa_pred).cisa_gen_opnd = pCisaBuilder->CISA_create_predicate_operand(upppered, MODIFIER_NONE, (yyvsp[-3].pred_state).cisa_state, (yyvsp[-1].string), CISAlineno);
            }
#line 3556 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 205:
#line 1382 "CISA.y"
    {
                (yyval.pred_state).cisa_state = PredState_NO_INVERSE;
                //$$.state = PredState_Plus;
            }
#line 3565 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 206:
#line 1387 "CISA.y"
    {
                (yyval.pred_state).cisa_state = PredState_INVERSE;
                //$$.state = PredState_Minus;
            }
#line 3574 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 207:
#line 1393 "CISA.y"
    {(yyval.string) = "";}
#line 3580 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 208:
#line 1395 "CISA.y"
    {(yyval.string) = (yyvsp[0].string);}
#line 3586 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 209:
#line 1398 "CISA.y"
    {(yyval.sat) = false;}
#line 3592 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 210:
#line 1400 "CISA.y"
    {(yyval.sat) = true;}
#line 3598 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 211:
#line 1403 "CISA.y"
    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 3604 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 212:
#line 1404 "CISA.y"
    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 3610 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 213:
#line 1405 "CISA.y"
    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 3616 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 214:
#line 1406 "CISA.y"
    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 3622 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 215:
#line 1409 "CISA.y"
    {
                //$$.mod = Mod_cond_undef;
                (yyval.cond_mod).cisa_mod = ISA_CMP_UNDEF;
             }
#line 3631 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 216:
#line 1414 "CISA.y"
    {
            //$$.mod = Get_G4_CondModifier_From_Common_ISA_CondModifier($1);
            (yyval.cond_mod).cisa_mod = (yyvsp[0].mod);
          }
#line 3640 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 217:
#line 1423 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS; }
#line 3646 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 218:
#line 1426 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3652 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 219:
#line 1429 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3658 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 220:
#line 1431 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT; }
#line 3664 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 221:
#line 1435 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE; }
#line 3670 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 222:
#line 1437 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT; }
#line 3676 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 223:
#line 1439 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT; }
#line 3682 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 224:
#line 1441 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3688 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 225:
#line 1443 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3694 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 226:
#line 1445 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS; }
#line 3700 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 227:
#line 1447 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF; }
#line 3706 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 228:
#line 1450 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE; }
#line 3712 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 229:
#line 1452 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT; }
#line 3718 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 230:
#line 1454 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT; }
#line 3724 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 231:
#line 1456 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3730 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 232:
#line 1458 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3736 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 233:
#line 1461 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE; }
#line 3742 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 234:
#line 1463 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3748 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 235:
#line 1465 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3754 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 236:
#line 1467 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF; }
#line 3760 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 237:
#line 1470 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3766 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 238:
#line 1472 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL; }
#line 3772 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 239:
#line 1474 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS; }
#line 3778 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 240:
#line 1476 "CISA.y"
    { (yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF; }
#line 3784 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 241:
#line 1489 "CISA.y"
    {
                (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].number);
                (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].number);
            }
#line 3793 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 242:
#line 1495 "CISA.y"
    {
                //$$.fbrMbMode = $2.opnd;
                //$$.fbrSubMbShape = $4.opnd;
                //$$.fbrSubPredMode = $6.opnd;

                (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
                (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
                (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
            }
#line 3807 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 243:
#line 1505 "CISA.y"
    {
                    //$$.dcl = NULL;
                    (yyval.StateVar).type = S_OPND_ERROR;
                 }
#line 3816 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 244:
#line 1510 "CISA.y"
    {
                    (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].number);
                    (yyval.StateVar).cisa_gen_opnd = pCisaBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].number), CISAlineno, false);
                }
#line 3825 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 245:
#line 1515 "CISA.y"
    {
                    //$$.dcl = NULL;
                    (yyval.StateVar).type = S_OPND_ERROR;
                 }
#line 3834 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 246:
#line 1520 "CISA.y"
    {
                    (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].number);
                    (yyval.StateVar).cisa_gen_opnd = pCisaBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].number), CISAlineno, true);
                }
#line 3843 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 247:
#line 1529 "CISA.y"
    {
                   (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_set_address_operand((yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true);
               }
#line 3851 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 248:
#line 1533 "CISA.y"
    {
                            //$$.dcl=NULL;
                            (yyval.RawVar).offset = 0;
                            (yyval.RawVar).cisa_gen_opnd = NULL;
                         }
#line 3861 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 249:
#line 1539 "CISA.y"
    {
                  TRACE("\n** Raw operand");
                  /*
                        Handles a case like in dword_write where
                        a src is NULL "V0"
                  */
                  if(strcmp((yyvsp[-2].string), "V0")==0)
                  {
                    //$$.dcl = NULL;
                    (yyval.RawVar).offset = 0;
                  }else
                  {
                    //variable_declaration_and_type_check($1, GENERAL_VAR);

                    //$$.dcl = pBuilder->dclpool.lookupDeclare($1);
                    (yyval.RawVar).offset = (unsigned short)(yyvsp[0].number);
                  }

                  (yyval.RawVar).cisa_gen_opnd = pCisaBuilder->CISA_create_RAW_operand((yyvsp[-2].string), (unsigned short)(yyvsp[0].number), CISAlineno);
               }
#line 3886 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 250:
#line 1560 "CISA.y"
    {
                    //$$.dcl = NULL;
                    (yyval.RawVar).offset = 0;
                    (yyval.RawVar).cisa_gen_opnd = pCisaBuilder->CISA_create_RAW_NULL_operand(CISAlineno);
               }
#line 3896 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 251:
#line 1567 "CISA.y"
    {
                    (yyval.number) = 0;
               }
#line 3904 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 252:
#line 1571 "CISA.y"
    {
                    rawOperandArray[(yyvsp[-1].number)++] = (VISA_RawOpnd*) (yyvsp[0].RawVar).cisa_gen_opnd;
                    (yyval.number) = (yyvsp[-1].number);
               }
#line 3913 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 253:
#line 1578 "CISA.y"
    {
                      TRACE("\n** Dest general operand");

                      //VISA_Type data_type = variable_declaration_and_type_check($1, GENERAL_VAR);

                      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_dst_general_operand((yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].number), CISAlineno);
                      if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                          YYABORT; // error is already reported
                  }
#line 3927 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 254:
#line 1590 "CISA.y"
    {
                      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_indirect_dst((yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type));
                      if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                          YYABORT; // error is already reported
                  }
#line 3937 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 255:
#line 1600 "CISA.y"
    {
                 (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0);
             }
#line 3945 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 256:
#line 1604 "CISA.y"
    {
                 (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_set_address_expression((yyvsp[-2].regAccess).cisa_decl, (-1) * (short)(yyvsp[0].number));
             }
#line 3953 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 257:
#line 1608 "CISA.y"
    {
                 (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_set_address_expression((yyvsp[-2].regAccess).cisa_decl, (short)(yyvsp[0].number));
             }
#line 3961 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 258:
#line 1614 "CISA.y"
    {
                  (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_set_address_operand((yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false);
                  if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                      YYABORT; // error is already reported
               }
#line 3971 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 259:
#line 1622 "CISA.y"
    {
                      //$$.opnd = pBuilder->CISA_src_general_operand($1, $3.rgn, Mod_src_undef, $2.row, $2.elem, CISAlineno);
                      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_gen_src_operand((yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno);
                      if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                          YYABORT; // error is already reported
                  }
#line 3982 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 260:
#line 1631 "CISA.y"
    {
                      //$$.opnd = pBuilder->CISA_src_general_operand($2, $4.rgn, $1.srcMod, $3.row, $3.elem, CISAlineno);
                      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_gen_src_operand((yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno);
                      if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                          YYABORT; // error is already reported
                  }
#line 3993 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 265:
#line 1645 "CISA.y"
    {
                      //G4_SrcRegRegion src(Mod_src_undef, $1.acc, $1.opnd, $1.row, $1.elem, $2.rgn, GetGenTypeFromVISAType($3), "");
                      //src.setImmAddrOff($1.immOff);
                      //$$.opnd = pBuilder->createSrcRegRegion(src);
                      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_indirect((yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type));
                      if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                          YYABORT; // error is already reported
                  }
#line 4006 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 266:
#line 1656 "CISA.y"
    {
                      //G4_SrcRegRegion src($1.srcMod, $2.acc, $2.opnd, $2.row, $2.elem, $3.rgn, GetGenTypeFromVISAType($4), "");
                      //src.setImmAddrOff($2.immOff);
                      //$$.opnd = pBuilder->createSrcRegRegion(src);
                      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_indirect((yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type));
                      if ((yyval.genOperand).cisa_gen_opnd == nullptr)
                          YYABORT; // error is already reported
                  }
#line 4019 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 267:
#line 1667 "CISA.y"
    {
                 MUST_HOLD(((yyvsp[-1].number) == 0 || (yyvsp[-1].number) == 1 || (yyvsp[-1].number) == 2 || (yyvsp[-1].number) == 4),
                         "HorzStride must be 0, 1, 2, or 4");
                 (yyval.number) = (yyvsp[-1].number);
             }
#line 4029 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 268:
#line 1674 "CISA.y"
    {
                (yyval.cisa_region).v_stride = 0;
                (yyval.cisa_region).width = 0;
                (yyval.cisa_region).h_stride = 0;
                //$$.rgn = NULL;
            }
#line 4040 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 269:
#line 1681 "CISA.y"
    {
               MUST_HOLD(((yyvsp[-5].number) == 0 || (yyvsp[-5].number) == 1 || (yyvsp[-5].number) == 2 || (yyvsp[-5].number) == 4 || (yyvsp[-5].number) == 8 || (yyvsp[-5].number) == 16 || (yyvsp[-5].number) == 32),
                         "VertStride must be 0, 1, 2, 4, 8, 16, or 32");
               MUST_HOLD(((yyvsp[-3].number) == 0 || (yyvsp[-3].number) == 1 || (yyvsp[-3].number) == 2 || (yyvsp[-3].number) == 4 || (yyvsp[-3].number) == 8 || (yyvsp[-3].number) == 16),
                         "Width must be 0, 1, 2, 4, 8 or 16");
               MUST_HOLD(((yyvsp[-1].number) == 0 || (yyvsp[-1].number) == 1 || (yyvsp[-1].number) == 2 || (yyvsp[-1].number) == 4),
                         "HorzStride must be 0, 1, 2, or 4");
               (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].number);
               (yyval.cisa_region).width = (unsigned)(yyvsp[-3].number);
               (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].number);
               //$$.rgn = pBuilder->rgnpool.createRegion($2, $4, $6);
           }
#line 4057 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 270:
#line 1694 "CISA.y"
    {(yyval.cisa_region) = (yyvsp[0].cisa_region);}
#line 4063 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 271:
#line 1695 "CISA.y"
    {(yyval.cisa_region) = (yyvsp[0].cisa_region);}
#line 4069 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 272:
#line 1696 "CISA.y"
    {(yyval.cisa_region) = (yyvsp[0].cisa_region);}
#line 4075 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 273:
#line 1699 "CISA.y"
    {
                (yyval.cisa_region).v_stride = -1;
                (yyval.cisa_region).width = -1;
                (yyval.cisa_region).h_stride = -1;
                //$$.rgn = NULL;
            }
#line 4086 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 274:
#line 1706 "CISA.y"
    {
               MUST_HOLD(((yyvsp[-5].number) == 0 || (yyvsp[-5].number) == 1 || (yyvsp[-5].number) == 2 || (yyvsp[-5].number) == 4 || (yyvsp[-5].number) == 8 || (yyvsp[-5].number) == 16 || (yyvsp[-5].number) == 32),
                         "VertStride must be 0, 1, 2, 4, 8, 16, or 32");
               MUST_HOLD(((yyvsp[-3].number) == 0 || (yyvsp[-3].number) == 1 || (yyvsp[-3].number) == 2 || (yyvsp[-3].number) == 4 || (yyvsp[-3].number) == 8 || (yyvsp[-3].number) == 16),
                         "Width must be 0, 1, 2, 4, 8 or 16");
               MUST_HOLD(((yyvsp[-1].number) == 0 || (yyvsp[-1].number) == 1 || (yyvsp[-1].number) == 2 || (yyvsp[-1].number) == 4),
                         "HorzStride must be 0, 1, 2, or 4");
               (yyval.cisa_region).v_stride = (unsigned int)(yyvsp[-5].number);
               (yyval.cisa_region).width = (unsigned)(yyvsp[-3].number);
               (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].number);
               //$$.rgn = pBuilder->rgnpool.createRegion($2, $4, $6);
           }
#line 4103 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 275:
#line 1720 "CISA.y"
    {
               MUST_HOLD(((yyvsp[-3].number) == 0 || (yyvsp[-3].number) == 1 || (yyvsp[-3].number) == 2 || (yyvsp[-3].number) == 4 || (yyvsp[-3].number) == 8 || (yyvsp[-3].number) == 16),
                         "Width must be 0, 1, 2, 4, 8 or 16");
               MUST_HOLD(((yyvsp[-1].number) == 0 || (yyvsp[-1].number) == 1 || (yyvsp[-1].number) == 2 || (yyvsp[-1].number) == 4),
                         "HorzStride must be 0, 1, 2, or 4");
               (yyval.cisa_region).v_stride = -1;
               (yyval.cisa_region).width = (unsigned)(yyvsp[-3].number);
               (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].number);
               //$$.rgn = pBuilder->rgnpool.createRegion(UNDEFINED_SHORT, $2, $4);
           }
#line 4118 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 276:
#line 1732 "CISA.y"
    {
             MUST_HOLD(((yyvsp[-1].number) == 0 || (yyvsp[-1].number) == 1 || (yyvsp[-1].number) == 2 || (yyvsp[-1].number) == 4),
                         "HorzStride must be 0, 1, 2, or 4");

             (yyval.cisa_region).v_stride = -1;
             (yyval.cisa_region).width = -1;
             (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].number);
             //$$.rgn = pBuilder->rgnpool.createRegion(UNDEFINED_SHORT, UNDEFINED_SHORT, (uint16_t)$2);
         }
#line 4132 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 277:
#line 1745 "CISA.y"
    {
                 TRACE(" The variable of the indirect operand \n");
                 (yyval.regAccess) = (yyvsp[-1].regAccess);
                 //$$.acc = IndirGRF;
             }
#line 4142 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 278:
#line 1752 "CISA.y"
    {
                 //$$.opnd = $1.opnd;
                 (yyval.regAccess).cisa_decl = (yyvsp[-1].regAccess).cisa_decl;
                 (yyval.regAccess).row = (yyvsp[-1].regAccess).row;
                 (yyval.regAccess).elem = (yyvsp[-1].regAccess).elem;
                 (yyval.regAccess).immOff = (int)(yyvsp[0].number);
             }
#line 4154 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 279:
#line 1761 "CISA.y"
    {(yyval.number) = 0;}
#line 4160 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 280:
#line 1763 "CISA.y"
    {
                    MUST_HOLD(((yyvsp[0].number) <= 1023 && (yyvsp[0].number) >= -1024), "imm addr offset must be -1024 .. 1023");
                    (yyval.number) = (yyvsp[0].number);
                }
#line 4169 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 281:
#line 1769 "CISA.y"
    {
              (yyval.offset).row = (int)(yyvsp[-3].number);
              (yyval.offset).elem = (int)(yyvsp[-1].number);
          }
#line 4178 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 282:
#line 1775 "CISA.y"
    {
              TRACE("\n** Address operand");
              (yyval.regAccess).cisa_decl = pCisaBuilder->CISA_find_decl((yyvsp[0].string));
              if (!(yyval.regAccess).cisa_decl)
                  PARSE_ERROR("unbound variable");
              (yyval.regAccess).row = 0;
              (yyval.regAccess).elem = 0;
          }
#line 4191 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 283:
#line 1784 "CISA.y"
    {
              TRACE("\n** Address operand");

              (yyval.regAccess).cisa_decl = pCisaBuilder->CISA_find_decl((yyvsp[-3].string));
              if (!(yyval.regAccess).cisa_decl)
                  PARSE_ERROR("unbound variable");
              (yyval.regAccess).row = 1;
              (yyval.regAccess).elem = (int)(yyvsp[-1].number);
          }
#line 4205 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 284:
#line 1795 "CISA.y"
    {
              TRACE("\n** Address operand");

              (yyval.regAccess).cisa_decl = pCisaBuilder->CISA_find_decl((yyvsp[-6].string));
              if (!(yyval.regAccess).cisa_decl)
                  PARSE_ERROR("unbound variable");
              (yyval.regAccess).row = (int)(yyvsp[-1].number);
              (yyval.regAccess).elem = (int)(yyvsp[-4].number);
          }
#line 4219 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 285:
#line 1805 "CISA.y"
    {
              TRACE("\n** Address operand");
              (yyval.regAccess).cisa_decl = pCisaBuilder->CISA_find_decl((yyvsp[-5].string));
              if (!(yyval.regAccess).cisa_decl)
                  PARSE_ERROR("unbound variable");
              (yyval.regAccess).row = (int)(yyvsp[-3].number);
              (yyval.regAccess).elem = (int)(yyvsp[-1].number);
          }
#line 4232 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 286:
#line 1814 "CISA.y"
    {
              // Both GENERAL_VAR and SURFACE_VAR are addressable
              //$$.opnd = pBuilder->getRegVar($1);
              (yyval.regAccess).cisa_decl = pCisaBuilder->CISA_find_decl((yyvsp[0].string));
              if (!(yyval.regAccess).cisa_decl)
                  PARSE_ERROR("unbound variable");
              (yyval.regAccess).row = 0;
              (yyval.regAccess).elem = 0;
          }
#line 4246 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 287:
#line 1825 "CISA.y"
    {(yyval.number) = 0;}
#line 4252 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 288:
#line 1827 "CISA.y"
    {
                MUST_HOLD(((yyvsp[0].number) < 0xF), "PlaneID must less than 0xF");
                (yyval.number) = (yyvsp[0].number);
            }
#line 4261 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 289:
#line 1834 "CISA.y"
    { (yyval.number) = 0; }
#line 4267 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 290:
#line 1836 "CISA.y"
    {
               MUST_HOLD(((yyvsp[-1].number) == 8 || (yyvsp[-1].number) == 16),
                         "SIMD mode can only be 8 or 16");
               (yyval.number) = (yyvsp[-1].number);
           }
#line 4277 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 291:
#line 1843 "CISA.y"
    { (yyval.string) = 0; }
#line 4283 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 292:
#line 1845 "CISA.y"
    {
                (yyval.string) = (yyvsp[0].string);
            }
#line 4291 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 293:
#line 1852 "CISA.y"
    {
               TRACE("\n** Element Number");
               (yyval.number) = (yyvsp[0].number);
           }
#line 4300 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 294:
#line 1858 "CISA.y"
    {
                (yyval.emask_exec_size).exec_size = UNDEFINED_EXEC_SIZE;
                (yyval.emask_exec_size).emask = vISA_EMASK_M1;
           }
#line 4309 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 295:
#line 1863 "CISA.y"
    {
               TRACE("\n** Execution Size ");
               (yyval.emask_exec_size).emask = vISA_EMASK_M1;
               (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].ushortnum);
           }
#line 4319 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 296:
#line 1869 "CISA.y"
    {
               /* */
               TRACE("\n** Execution Size With Offset ");
               if (!ParseEMask(pCisaBuilder, (yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
                    PARSE_ERROR("invalid execution offset info");
               }
               (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].ushortnum);
           }
#line 4332 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 297:
#line 1878 "CISA.y"
    {
           if ((yyvsp[0].number) != 1 && (yyvsp[0].number) != 2 && (yyvsp[0].number) != 4 && (yyvsp[0].number) != 8 && (yyvsp[0].number) != 16 && (yyvsp[0].number) != 32) {
                PARSE_ERROR("invalid execution size");
           }
           (yyval.ushortnum) = (unsigned short)(yyvsp[0].number);
        }
#line 4343 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 298:
#line 1887 "CISA.y"
    {
#if 0
      (yyval.genOperand) = pBuilder->createImmWithLowerType((yyvsp[-1].number), (yyvsp[0].type) );
#else
      //for CISA binary builder need original type. Don't want to modify all the G4_Imm
      //data structures now.
      //$$.opnd = pBuilder->createImm($1, GetGenTypeFromVISAType($2) );
      (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_immed((yyvsp[-1].number), (yyvsp[0].type), CISAlineno);
#endif
      }
#line 4358 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 299:
#line 1898 "CISA.y"
    { (yyval.number) = (yyvsp[0].number); }
#line 4364 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 300:
#line 1899 "CISA.y"
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 4370 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 301:
#line 1900 "CISA.y"
    { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number); }
#line 4376 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 302:
#line 1901 "CISA.y"
    { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number); }
#line 4382 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 303:
#line 1902 "CISA.y"
    {
            if ((yyvsp[0].number) == 0)
                CISAerror(pCisaBuilder, "division by 0");
            (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number);
        }
#line 4392 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 304:
#line 1907 "CISA.y"
    { (yyval.number) = -(yyvsp[0].number); }
#line 4398 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 305:
#line 1908 "CISA.y"
    { (yyval.number) = (yyvsp[-1].number); }
#line 4404 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 306:
#line 1911 "CISA.y"
    {(yyval.number) = (yyvsp[0].number);}
#line 4410 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 307:
#line 1913 "CISA.y"
    {(yyval.number) = (yyvsp[0].number);}
#line 4416 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 308:
#line 1917 "CISA.y"
    {   (yyval.fp) = (yyvsp[0].fp); }
#line 4422 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 309:
#line 1919 "CISA.y"
    {
                    /* "1:df" means 5e-324 */
                    int64_t number = (yyvsp[-1].number);
                    double *fp = (double *)&number;
                    (yyval.fp) = *fp;
               }
#line 4433 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 310:
#line 1926 "CISA.y"
    {
                    int64_t number = (yyvsp[-1].number);
                    double *fp = (double *)&number;
                    (yyval.fp) = *fp;
               }
#line 4443 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 311:
#line 1933 "CISA.y"
    {   char floatstring[256];
                    sprintf_s(floatstring, sizeof(floatstring), "%" PRId64 ".%" PRId64, (yyvsp[-2].number), (yyvsp[0].number));
                    (yyval.fp) = atof(floatstring);
                }
#line 4452 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 312:
#line 1938 "CISA.y"
    {   (yyval.fp) = (yyvsp[0].fp); }
#line 4458 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 313:
#line 1940 "CISA.y"
    {
                    (yyval.fp) = (yyvsp[-1].number)*1.0f;
                }
#line 4466 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 314:
#line 1944 "CISA.y"
    {
                    /* "1:f" means 1.4e-45 */
                    int number = (int)(yyvsp[-1].number);
                    float *fp = (float *)&number;
                    (yyval.fp) = *fp;
               }
#line 4477 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 315:
#line 1951 "CISA.y"
    {
                    int number = (int)(yyvsp[-1].number);
                    float *fp = (float *)&number;
                    (yyval.fp) = *fp;
               }
#line 4487 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 316:
#line 1958 "CISA.y"
    {
         //$$.opnd = pBuilder->createDFImm($1);
         (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_float_immed((yyvsp[0].fp), ISA_TYPE_DF, CISAlineno);
       }
#line 4496 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 317:
#line 1963 "CISA.y"
    {
         //$$.opnd = pBuilder->createDFImm($2 * (-1));
         (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_float_immed((yyvsp[0].fp) * (-1), ISA_TYPE_DF, CISAlineno);
       }
#line 4505 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 318:
#line 1970 "CISA.y"
    {
           //$$.opnd = pBuilder->createImm($1);
           (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_float_immed((yyvsp[0].fp), ISA_TYPE_F, CISAlineno);
       }
#line 4514 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 319:
#line 1975 "CISA.y"
    {
           //$$.opnd = pBuilder->createImm($2 * (-1));
           (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_float_immed((yyvsp[0].fp) * (-1), ISA_TYPE_F, CISAlineno);
       }
#line 4523 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 320:
#line 1981 "CISA.y"
    {
           (yyval.genOperand).cisa_gen_opnd = pCisaBuilder->CISA_create_immed((unsigned short)(yyvsp[-1].number), ISA_TYPE_HF, CISAlineno);
      }
#line 4531 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 321:
#line 1986 "CISA.y"
    {(yyval.type) = (yyvsp[0].type);}
#line 4537 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 322:
#line 1987 "CISA.y"
    {(yyval.type) = (yyvsp[0].type);}
#line 4543 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 323:
#line 1988 "CISA.y"
    {(yyval.type) = (yyvsp[0].type);}
#line 4549 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 324:
#line 1989 "CISA.y"
    {(yyval.type) = (yyvsp[0].type);}
#line 4555 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 325:
#line 1990 "CISA.y"
    {(yyval.type) = (yyvsp[0].type);}
#line 4561 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 326:
#line 1994 "CISA.y"
    {
                //pBuilder->addComment($1);
            }
#line 4569 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 327:
#line 1999 "CISA.y"
    { (yyval.pixel_null_mask) = false; }
#line 4575 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 328:
#line 2001 "CISA.y"
    {
             (yyval.pixel_null_mask) = true;
             TRACE("** PIXEL_NULL_MASK ");
         }
#line 4584 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 329:
#line 2006 "CISA.y"
    { (yyval.cps) = false; }
#line 4590 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 330:
#line 2008 "CISA.y"
    {
             (yyval.cps) = true;
             TRACE("** CPS LOD compensation a");
         }
#line 4599 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 331:
#line 2013 "CISA.y"
    { (yyval.non_uniform_sampler) = false; }
#line 4605 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 332:
#line 2015 "CISA.y"
    {
             (yyval.non_uniform_sampler) = true;
             TRACE("** non-uniform sampler state");
         }
#line 4614 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 333:
#line 2020 "CISA.y"
    { (yyval.flag) = false ; }
#line 4620 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 334:
#line 2022 "CISA.y"
    {
             MUST_HOLD(((yyvsp[0].number) == 16), "Only supports 16.");
             (yyval.flag) = true;
             TRACE("** atomic 16");
         }
#line 4630 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 335:
#line 2028 "CISA.y"
    { (yyval.ushortnum) = 32; }
#line 4636 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;

  case 336:
#line 2029 "CISA.y"
    {
            MUST_HOLD(((yyvsp[0].number) == 16 || (yyvsp[0].number) == 64 ), "Only supports 16/64.");
            TRACE("\n** atomic NUMBER");
            (yyval.ushortnum) = (unsigned short)(yyvsp[0].number);
        }
#line 4646 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"
    break;


#line 4650 "/builddir/build/BUILD/intel-graphics-compiler-6934fa8d2714031192e8d67cf54d89b68b1ff74e/build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (pCisaBuilder, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (pCisaBuilder, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pCisaBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, pCisaBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (pCisaBuilder, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pCisaBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, pCisaBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2035 "CISA.y"


void CISAerror(CISA_IR_Builder* pCisaBuilder, char const *s)
{
    /*
    int yytype = YYTRANSLATE (yychar);
    if (strcmp(yytname[yytype], "NUMBER") == 0)
        fprintf (stderr, "\nLine %d: %s, number: %" PRId64 "\n", CISAlineno,  s, yylval.number);
     else if (strcmp(yytname[yytype], "VAR") == 0)
        fprintf (stderr, "\nLine %d: %s, symbol: %s\n", CISAlineno,  s, yylval.string);
     else
        fprintf (stderr, "\nLine %d: %s\n", CISAlineno,  s);
        */

    pCisaBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pCisaBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "32word") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "64word") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}

static bool ParseEMask(
    CISA_IR_Builder* pCisaBuilder,
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

